# Process Form Field Permissions

## Query the field permission specified in the process
Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/auth${suffix} <br>
**Post Data Description：**
```
{
  "accessToken": "",
  "authId":""
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| authId      | No       | Process Form Field Permission ID               |
**Example of returned results：**
```
{
  "code": 0,
  "data": {
    "formId": "HZ28858f809c392401809c3d514e0035",
    "authName": "auth_test",
    "checkField": [
      "HZ28858f809c392401809c3d514e0035_NAME"
    ],
    "editField": [
      "HZ28858f809c392401809c3d514e0035_NAME"
    ],
    "hiddenField": [],
    "readField": [
      "HZ28858f809c392401809c3d514e0035_P2",
      "HZ28858f809c392401809c3d514e0035_P1"
    ]
  },
  "message": "",
  "success": true
}
```
**Result parameter description:**

| Parameter   | Type   | Description                                                                           |
|-------------|--------|---------------------------------------------------------------------------------------|
| formId      | String | Form id                                                                               |
| authName    | String | Permission Name                                                                       |
| editField   | List   | Editable fields, each item is a concatenation of form id and associated table fields  |
| checkField  | List   | Required fields, each item is a concatenation of form id and associated table fields  |
| hiddenField | List   | Hidden fields, each item is a concatenation of form id and associated table fields    |
| readField   | List   | Read only fields, each item is a concatenation of form id and associated table fields |
