# Add/Remove Reviewer
> Pre-add Reviewer,Add Reviewer,Reduce Reviewer

## Pre-add Reviewer
> Suitable for multi operator order nodes, adding new operator before existing operators.

Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b018117f86ce3034e",
  "trackId": "HZ28858f8113f08b018117f86ce3034f",
  "actionData": {
    "operate": "jiaqianBefore",
    "operateFlag": 0,
    "operateClazz": "com.horizon.wf.action.ActionJiaQianBefore",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User01(Test Department0)"
          }
        },
        "isSelect": "true",
        "nodeKey": "Node1",
        "nodeId": "Node1",
        "selectId": "Node1"
      }
    ]
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Process operation JSON data                    |
actionData  parameter:

| Parameter    | Required | Description                                                                               |
|--------------|----------|-------------------------------------------------------------------------------------------|
| operate      | Yes      | Operation identification of 'Pre-add Reviewer',fix value 'jiaqianBefore'                  |
| operateFlag  | Yes      | Operation identifier, fixed value 0                                                       |
| operateClazz | Yes      | Operation path of 'Pre-add Reviewer',fix value: com.horizon.wf.action.ActionJiaQianBefore |
| nextNodes    | Yes      | List of nodes that need to be set                                                         |
nextNodes parameter description

| Parameter | Required | Description                                                                                         |
|-----------|----------|-----------------------------------------------------------------------------------------------------|
| authors   | Yes      | The key in the operator object of next node is Author, and the value is the Author object parameter |
| isSelect  | Yes      | Has the node been selected, fixed value 'True'                                                      |
| nodeKey   | Yes      | Node primary key                                                                                    |
| nodeId    | Yes      | Node ID                                                                                             |
| selectId  | Yes      | Node ID to be selected                                                                              |
Author Object Parameter Description in Authors：

| Parameter        | Required | Description                            |
|------------------|----------|----------------------------------------|
| selectAuthor     | Yes      | The selected operator ID of the node   |
| selectAuthorName | Yes      | The selected operator name of the node |
**Example of returned results:**
```
{
  "nextNodeId": "Node1",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "Primary",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectType": "checkbox"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "isShowTabs": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node1",
      "nodeKey": "Node1",
      "nodeName": "Task1",
      "nodeStatus": "0",
      "selectId": "Node1",
      "selectName": "Pre-add Reviewer(Task1)"
    }
  ],
  "operate": "jiaqianBefore",
  "operateClazz": "com.horizon.wf.action.ActionJiaQianBefore",
  "operateFlag": "0",
  "operateMsg": "Add reviewer successfully",
  "status": 0,
  "workId": "HZ28858f8113f08b018117f86ce3034e"
}
```
**Result parameter description:**

| Parameter    | Type   | Description                                                                        |
|--------------|--------|------------------------------------------------------------------------------------|
| nextNodeId   | String | Next node ID (used when the next node ID is known and there is only one next node) |
| nextNodes    | List   | List of next nodes to be selected                                                  |
| operate      | String | Operation identification of Pre-Add Reviewer                                       |
| operateClazz | String | Operation path of Pre-Add Reviewer                                                 |
| operateFlag  | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission         |
| operateMsg   | String | Return operation information                                                       |
| status       | int    | Process operation status code                                                      |
| workId       | String | Instance ID                                                                        |
*nextNodes parameter description*

| Parameter  | Type   | Description                                                                                                                                                                                          |
|------------|--------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| authors    | Map    | The key in the operator map of the next node is Primary Operator, and value is the Primary Operator object parameter                                                                                 |
| isDone     | String | Has it already passed by                                                                                                                                                                             |
| isSelect   | String | Has it been selected                                                                                                                                                                                 |
| isShowTabs | String | Whether to display operator tab page of the process node                                                                                                                                             |
| memo       | String | Memo                                                                                                                                                                                                 |
| nodeGroup  | String | If there are no multiple branches in the current instance, this value is empty. If there are multiple branches, this value returns the node ID of the previous node to bind the grouping information |
| nodeId     | String | Node  ID                                                                                                                                                                                             |
| nodeKey    | String | Node  primary Key                                                                                                                                                                                    |
| nodeName   | String | Node name                                                                                                                                                                                            |
| nodeStatus | String | Node status, limited value, 0. Success; 1. Select operator; 2. Select node; 3. Operator not found;4. Next node not found                                                                             |
| selectId   | String | Node ID to be selected                                                                                                                                                                               |
| selectName | String | Node name to be selected                                                                                                                                                                             |
*authors中Author parameter description*

| Parameter     | Type   | Description                                                                             |
|---------------|--------|-----------------------------------------------------------------------------------------|
| authorFlowVar | String | The selected operator ID of the node                                                    |
| freeArea      | String | The selected operator name of the node                                                  |
| authorId      | String | Operator ID,Fixed value: Primary Operator                                               |
| authorName    | String | Operator name: Primary,Secondary,Reader                                                 |
| isFree        | String | Whether to choose freely                                                                |
| isUser        | String | Is it allowed to only select user?                                                      |
| isDefUser     | String | Select from the organization library of process node attributes                         |
| isSelect      | String | Is it allowed to select the operator?                                                   |
| selectType    | String | User selection type, limited value,Radio: Single selection;Checkbox: Multiple selection |

## Add Reviewer
> Suitable for multi operator order node,multi operator nodes, adding new operator after existing operators.

Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b0181189a461e03be",
  "trackId": "HZ28858f8113f08b0181189a461e03bf",
  "actionData": {
    "operate": "jiaqian",
    "operateFlag": 0,
    "operateClazz": "com.horizon.wf.action.ActionJiaQian",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User01(Test Department0)"
          }
        },
        "isSelect": "true",
        "nodeKey": "Node1",
        "nodeId": "Node1",
        "selectId": "Node1"
      }
    ]
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Process operation JSON data                    |
actionData  parameter:

| Parameter           | Required | Description                                            |
|--------------|------|-----------------------------------------------|
| operate      | Yes    | Add reviewer operation identifier, fixed value 'jiaqian'               |
| operateFlag  | Yes    | Operation identifier, fixed value '0'                                     |
| operateClazz | Yes    | Add reviewer operation implementation class, fixed value:com.horizon.wf.action.ActionJiaQian |
| nextNodes    | Yes    | List of nodes that need to be set                                     |
nextNodes parameter description

| Parameter | Required | Description                                                                                                             |
|-----------|----------|-------------------------------------------------------------------------------------------------------------------------|
| nodeKey   | Yes      | Node  primary Key                                                                                                       |
| isSelect  | Yes      | Has the node been selected, fixed value 'True'                                                                          |
| selectId  | Yes      | Node ID to be selected                                                                                                  |
| nodeId    | Yes      | Node ID to be selected                                                                                                  |
| authors   | Yes      | The key in the operator object of next node is Primary Operator, and the value is the Primary Operator object parameter |
Author object parameter description in Authors

| Parameter        | Required | Description                            |
|------------------|----------|----------------------------------------|
| selectAuthor     | Yes      | The selected operator ID of the node   |
| selectAuthorName | Yes      | The selected operator name of the node |
**Example of returned results:**
```
{
  "nextNodeId": "Node1",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "Primary",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectType": "checkbox"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "isShowTabs": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node1",
      "nodeKey": "Node1",
      "nodeName": "Task1",
      "nodeStatus": "0",
      "selectId": "Node1",
      "selectName": "Add reviewer(Task1)"
    }
  ],
  "operate": "jiaqian",
  "operateClazz": "com.horizon.wf.action.ActionJiaQian",
  "operateFlag": "0",
  "operateMsg": "Add reviewer successfully",
  "status": 0,
  "workId": "HZ28858f8113f08b0181189a461e03be"
}
```
**Result parameter description:**

| Parameter    | Type   | Description                                                                |
|--------------|--------|----------------------------------------------------------------------------|
| operate      | String | Add reviewer operation identification                                      |
| operateClazz | String | Add reviewer operation class path                                          |
| operateFlag  | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission |
| operateMsg   | String | Return operation information                                               |
| nextNodeId   | String | Current node ID                                                            |
| workId       | String | Instance ID                                                                |
| status       | int    | Process operation status code                                              |
| nextNodes    | List   | List of nodes to be selected                                               |
*nextNodes parameter description*

| Parameter  | Type   | Description                                                                                                                                                                                          |
|------------|--------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| nodeKey    | String | Node  primary Key                                                                                                                                                                                    |
| selectId   | String | Node ID to be selected                                                                                                                                                                               |
| selectName | String | Node name  to be selected                                                                                                                                                                            |
| isSelect   | String | Has it been selected                                                                                                                                                                                 |
| isDone     | String | Has it already passed by                                                                                                                                                                             |
| nodeGroup  | String | If there are no multiple branches in the current instance, this value is empty. If there are multiple branches, this value returns the node ID of the previous node to bind the grouping information |
| isShowTabs | String | Whether to display operator tab page of the process node                                                                                                                                             |
| nodeStatus | String | Node status, limited value, 0. Success; 1. Select operator; 2. Select node; 3. Operator not found;4. Next node not found                                                                             |
| authors    | Map    | The key in the operator map of the next node is Primary Operator, and value is the Primary Operator object parameter                                                                                 |
*Author parameter description*

| Parameter     | Type   | Description                                                                                  |
|---------------|--------|----------------------------------------------------------------------------------------------|
| authorFlowVar | String | The selected operator ID of the node                                                         |
| freeArea      | String | The selected operator name of the node                                                       |
| authorId      | String | Operator ID,fixed value Author                                                               |
| authorName    | String | Operator name: Primary,Secondary,Reader                                                      |
| selectType    | String | Personnel selection type, limited value; Radio: Single selection；Checkbox:Multiple selection |
| isFree        | String | Whether to choose freely                                                                     |
| isUser        | String | Is it allowed to only select user                                                            |
| isDefUser     | String | Select from the organization library of process node attributes                              |
| isSelect      | String | Is it allowed to select the operator                                                         |

## Remove Reviewer
>  Suitable for multi operator order node,multi operator nodes, remove the specified user from the current to-do operators on the processed instance node.

![flow operation](../../assets/img/rest/flowaction/jianqian.png)
### Remove-View reducible users
Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b0181189a461e03be",
  "trackId": "HZ28858f8113f08b0181189a461e03bf",
  "actionData": {
    "operate": "reduceAuthor",
    "operateClazz": "com.horizon.wf.action.ActionReduceAuthor"
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Process operation JSON data                    |
actionData  parameter:

| Parameter    | Required | Description                                                                                  |
|--------------|----------|----------------------------------------------------------------------------------------------|
| operate      | Yes      | Remove reviewer operation identifier, fixed value:'reduceAuthor'                             |
| operateClazz | Yes      | Remove reviewer implementation class, fixed value:'com.horizon.wf.action.ActionReduceAuthor' |
**Example of returned results:**
```
{
  "nextNodeId": "Node1",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "Primary",
          "freeArea": "",
          "initAuthor": {
            "others": [
              {
                "userFromId": "HZ28821856ef63420156ef6342a20001",
                "id": "HZ28821856ef63420156ef6342a20002",
                "userFromName": "Test department0",
                "title": "User01",
                "name": "User01",
                "iconSkin": "U",
                "userFromIconSkin": "D"
              },
              {
                "userFromId": "HZ28821856ef63420156ef6342a20001",
                "id": "HZ28821856ef63420156ef6342a20003",
                "userFromName": "Test department0",
                "title": "User02",
                "name": "User02",
                "iconSkin": "U",
                "userFromIconSkin": "D"
              },
              {
                "userFromId": "HZ28821856ef63420156ef6342a20001",
                "id": "HZ28821856ef63420156ef6342a20004",
                "userFromName": "Test department0",
                "title": "User03",
                "name": "User03",
                "iconSkin": "U",
                "userFromIconSkin": "D"
              }
            ]
          },
          "isDefUser": "true",
          "isFree": "false",
          "isSelect": "true",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001;U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001;U_HZ28821856ef63420156ef6342a20004/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "User01(Test department0);User02(Test department0);User03(Test department0)",
          "selectType": "checkbox"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node1",
      "nodeKey": "Node1",
      "nodeName": "Task1",
      "nodeStatus": "0",
      "selectId": "Node1",
      "selectName": "Reduce reviewer(Task1)"
    }
  ],
  "operate": "reduceAuthor",
  "operateClazz": "com.horizon.wf.action.ActionReduceAuthor",
  "operateFlag": "0",
  "operateMsg": "Please select the user who needs to be removed from the list.",
  "status": 4,
  "workId": "HZ28858f811e704701811ea661bc0095"
}
```
**Result parameter description:**

| Parameter    | Type   | Description                                                                        |
|--------------|--------|------------------------------------------------------------------------------------|
| nextNodeId   | String | Next node ID (used when the next node ID is known and there is only one next node) |
| nextNodes    | List   | List of next nodes to be selected                                                  |
| operate      | String | Remove reviewer operation identification                                           |
| operateClazz | String | Remove reviewer operation class path                                               |
| operateFlag  | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission         |
| operateMsg   | String | Return operation information                                                       |
| status       | int    | Process operation status code                                                      |
| workId       | String | Instance ID                                                                        |
*nextNodes parameter description*

| Parameter  | Type   | Description                                                                                                                                                                                          |
|------------|--------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| authors    | Map    | The key in the operator map of the next node is Primary Operator, and value is the Primary Operator object parameter                                                                                 |
| isDone     | String | Has it already passed by                                                                                                                                                                             |
| isSelect   | String | Has it been selected                                                                                                                                                                                 |
| memo       | String | Memo                                                                                                                                                                                                 |
| nodeGroup  | String | If there are no multiple branches in the current instance, this value is empty. If there are multiple branches, this value returns the node ID of the previous node to bind the grouping information |
| nodeId     | String | Node  ID                                                                                                                                                                                             |
| nodeKey    | String | Node  primary Key                                                                                                                                                                                    |
| nodeName   | String | Node name                                                                                                                                                                                            |
| nodeStatus | String | Node status, limited value, 0. Success; 1. Select operator; 2. Select node; 3. Operator not found;4. Next node not found                                                                             |
| selectId   | String | Node ID to be selected                                                                                                                                                                               |
| selectName | String | Node name  to be selected                                                                                                                                                                            |
*Author parameter description in 'authors'*

| Parameter        | Type   | Description                                                                             |
|------------------|--------|-----------------------------------------------------------------------------------------|
| authorFlowVar    | String | Flow variables                                                                          |
| authorId         | String | Operator ID,fixed value:Primary/Secondary/Reader                                        |
| authorName       | String | Operator name: Primary,Secondary,Reader                                                 |
| freeArea         | String | Scope of operators for free choice                                                      |
| initAuthor       | Object | Node initialization operator ID                                                         |
| isDefUser        | String | Select from the organization library of process node attributes                         |
| isFree           | String | Whether to choose freely                                                                |
| isSelect         | String | Is it allowed to select the operator                                                    |
| isUser           | String | Is it allowed to only select user                                                       |
| selectAuthor     | String | The selected operator ID of the node                                                    |
| selectAuthorName | String | The selected operator name of the node                                                  |
| selectType       | String | User selection type, limited value; Radio: Single selection；Checkbox:Multiple selection |
*initAuthor parameter description*

| Parameter | Type | Description                    |
|-----------|------|--------------------------------|
| others    | List | Initialize operator parameters |
*Description of initialization operator parameters:*

| Parameter        | Type   | Description                               |
|------------------|--------|-------------------------------------------|
| userFromId       | String | User's organization ID                    |
| id               | String | User ID                                   |
| userFromName     | String | Name of user's organization type          |
| title            | String | User name                                 |
| name             | String | User name                                 |
| iconSkin         | String | User identification                       |
| userFromIconSkin | String | Identification of the user's organization |

### Remove reviewer-Set up user for reducing reviewer
Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f811e704701811ea661bc0095",
  "trackId": "HZ28858f811e704701811ea661bc0096",
  "authorKey": "Author",
  "nodeId": "Node1",
  "nodeName": "Task1",
  "actionData": {
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User02(Test Department0)"
          }
        },
        "isSelect": "true",
        "nodeId": "Node1",
        "nodeKey": "Node1",
        "selectId": "Node1"
      }
    ],
    "operate": "reduceAuthor",
    "operateFlag": 0,
    "operateClazz": "com.horizon.wf.action.ActionReduceAuthor"
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| authorKey   | Yes      | Operator type ID                               |
| nodeId      | Yes      | Current node ID                                |
| nodeName    | Yes      | Current node name                              |
| actionData  | Yes      | Process operation JSON data                    |
actionData  parameter:

| Parameter    | Required | Description                                                                                |
|--------------|----------|--------------------------------------------------------------------------------------------|
| nextNodes    | Yes      | List of next nodes to be selected                                                          |
| operate      | Yes      | Remove reviewer operation identifier, fixed value:reduceAuthor                             |
| operateFlag  | Yes      | Operation identifier, fixed value 0                                                        |
| operateClazz | Yes      | Remove reviewer operation class path, fixed value:com.horizon.wf.action.ActionReduceAuthor |
nextNodes parameter description

| Parameter | Required | Description                                                                                         |
|-----------|----------|-----------------------------------------------------------------------------------------------------|
| authors   | Yes      | The key in the operator object of next node is Author, and the value is the Author object parameter |
| isSelect  | Yes      | Has the node been selected, fixed value:True                                                        |
| nodeId    | Yes      | Node ID to be selected                                                                              |
| nodeKey   | Yes      | Node  primary Key                                                                                   |
| selectId  | Yes      | Node ID to be selected                                                                              |
Author Object Parameter Description in Authors:

| Parameter        | Required | Description                            |
|------------------|----------|----------------------------------------|
| selectAuthor     | Yes      | The selected operator ID of the node   |
| selectAuthorName | Yes      | The selected operator name of the node |
**Example of returned results:**
```
{
    "authorKey": "Author",
    "nextNodeId": "Node1",
    "nextNodes": [
        {
            "authors": {
                "Author": {
                    "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
                    "selectAuthorName": "User02(Test depatment0)"
                }
            },
            "isSelect": "true",
            "nodeId": "Node1",
            "nodeKey": "Node1",
            "selectId": "Node1"
        }
    ],
    "nodeId": "Node1",
    "nodeName": "Task1",
    "operate": "reduceAuthor",
    "operateClazz": "com.horizon.wf.action.ActionReduceAuthor",
    "operateFlag": "0",
    "operateMsg": "Removed operator successfully ",
    "operateStatus": "success",
    "status": 0,
    "workId": "HZ28858f811e704701811ea661bc0095"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                                        |
|---------------|--------|------------------------------------------------------------------------------------|
| authorKey     | String | Operator type ID                                                                   |
| nextNodeId    | String | Next node ID (used when the next node ID is known and there is only one next node) |
| nextNodes     | List   | List of next nodes to be selected                                                  |
| nodeId        | String | Current node ID                                                                    |
| nodeName      | String | Current Node name                                                                  |
| operate       | String | Remove reviewer operation identification                                           |
| operateClazz  | String | Remove reviewer operation class path                                               |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission         |
| operateMsg    | String | Return operation information                                                       |
| operateStatus | String | Return operation results                                                           |
| status        | int    | Process operation status code                                                      |
| workId        | String | Instance ID                                                                        |
*nextNodes parameter description*

| Parameter | Type   | Description                                                                                                          |
|-----------|--------|----------------------------------------------------------------------------------------------------------------------|
| authors   | Map    | The key in the operator map of the next node is Primary Operator, and value is the Primary Operator object parameter |
| isSelect  | String | Has it been selected                                                                                                 |
| nodeId    | String | Curret node id                                                                                                       |
| nodeKey   | String | Node  primary Key                                                                                                    |
| selectId  | String | Node ID that needs to be operated on                                                                                 |
*authors中Author parameter description*

| Parameter        | Type   | Description                            |
|------------------|--------|----------------------------------------|
| selectAuthor     | String | The selected operator ID of the node   |
| selectAuthorName | String | The selected operator name of the node |