# Pause/Resume{docsify-ignore-all}
> Pause/Resume process instances

Interface Request Invoking Description<br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e0181049de50f008f",
  "trackId": "HZ28858f8103505e0181049de50f0090",
  "actionData": {
    "operate": "pause",
    "operateClazz": "com.horizon.wf.action.ActionPause"
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | instance ID                                    |
| trackId     | Yes      | Flow track id                                  |
| actionData  | Yes      | Other submitted data                           |
actionData Parameter:

| Parameter    | Required | Description                                                         |
|--------------|----------|---------------------------------------------------------------------|
| operate      | Yes      | Operation identification, fixed value 'pause'                       |
| operateClazz | Yes      | Pause/Resume Operation Class Path:com.horizon.wf.action.ActionPause |
**Example of returned results:**
```
{
  "alert": "True",
  "operate": "pause",
  "operateClazz": "com.horizon.wf.action.ActionPause",
  "operateFlag": "1",
  "operateMsg": "Successfully paused the process",
  "operateStatus": "success",
  "reOpen": "False",
  "status": 0,
  "workId": "HZ28858f8103505e0181049de50f008f"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                                |
|---------------|--------|----------------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored           |
| operate       | String | Pause/Resume Operation Identification                                      |
| operateClazz  | String | Pause/Resume Operation Class Path                                          |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission |
| operateMsg    | String | Process operation return information                                       |
| operateStatus | String | Process operation results                                                  |
| reOpen        | String | Whether to reopen, can be ignored                                          |
| status        | int    | Process operation status code                                              |
| workId        | String | Instance ID                                                                |
