# Return
> Return、List of nodes that can be returned 、Return to Any Node、Return Submission、Internally Return 

![Flow operattion](../../assets/img/rest/flowaction/reject.png)
## Return
Interface Request Invoking Description <br>
HTTP request method: POST <br>
Request address:: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b018113f08be70001",
  "trackId": "HZ28858f8113f08b018113f08be90002",
  "actionData": {
    "operate": "reject",
    "operateClazz": "com.horizon.wf.action.ActionReject"
  }
}
```

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Track ID                                       |
| actionData  | Yes      | Other submitted data                           |
actionData  parameter

| Parameter    | Required | Description                                                     |
|--------------|----------|-----------------------------------------------------------------|
| operate      | Yes      | 'Return' operation identifier, fixed value:'reject'             |
| operateClazz | Yes      | 'Return' operation class pathcom.horizon.wf.action.ActionReject |
**Example of returned results:**
```
{
  "alert": "true",
  "nodeId": "Node3",
  "operate": "reject",
  "operateClazz": "com.horizon.wf.action.ActionReject",
  "operateFlag": "1",
  "operateMsg": "Returned successfully",
  "operateStatus": "success",
  "status": 0,
  "trackId": "HZ28858f8113f08b018113f08be90002",
  "workId": "HZ28858f8113f08b018113f08be70001"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                                |
|---------------|--------|----------------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored           |
| nodeId        | String | Return node ID                                                             |
| operate       | String | 'Return' operation identification                                          |
| operateClazz  | String | 'Return' operation class path                                              |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission |
| operateMsg    | String | Process operation return information                                       |
| operateStatus | String | Process operation results                                                  |
| reOpen        | String | Whether to reopen, can be ignored                                          |
| status        | int    | Process operation status code                                              |
| workId        | String | Instance ID                                                                |

## Return to Any Node

### List of nodes that can be returned 、
Interface Request Invoking Description <br>HTTP request method: POST <br>
Request address:: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b018113f08be70001",
  "trackId": "HZ28858f8113f08b018113f08be90002",
  "actionData": {
    "operate": "jumpreject",
    "operateClazz": "com.horizon.wf.action.ActionRejectByJump"
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Track ID                                       |
| actionData  | Yes      | Other submitted data                           |
actionData  parameter

| Parameter           | Required | Description                                             |
|--------------|------|-------------------------------------------------|
| operate      | Yes    | 'Return' operation identifier, fixed value:'jumpreject'                            |
| operateClazz | Yes    | 'Return' operation class pathcom.horizon.wf.action.ActionRejectByJump |
**Example of returned results:**
```
{
  "nextNodeId": "",
  "nextNodes": [
    {
      "authors": {},
      "isDone": "false",
      "isSelect": "false",
      "memo": "",
      "nodeGroup": "Node0",
      "nodeId": "Node1",
      "nodeKey": "Node1",
      "nodeName": "Task1",
      "nodeStatus": "0",
      "selectId": "Node1",
      "selectName": "Task1",
      "timeLimit": "0",
      "timeLimitType": "1"
    },
    {
      "authors": {},
      "isDone": "false",
      "isSelect": "false",
      "memo": "",
      "nodeGroup": "Node0",
      "nodeId": "Node2",
      "nodeKey": "Node2",
      "nodeName": "Task2",
      "nodeStatus": "0",
      "selectId": "Node2",
      "selectName": "Task2",
      "timeLimit": "0",
      "timeLimitType": "1"
    }
  ],
  "operate": "jumpreject",
  "operateClazz": "com.horizon.wf.action.ActionRejectByJump",
  "operateFlag": "1",
  "operateMsg": "Please select a return node",
  "status": 2,
  "workId": "HZ28858f8113f08b018113f08be70001"
}
```
**Result parameter description:**

| Parameter    | Type   | Description                                                                        |
|--------------|--------|------------------------------------------------------------------------------------|
| nextNodeId   | String | Next node ID (used when the next node ID is known and there is only one next node) |
| nextNodes    | List   | List of next nodes to be selected                                                  |
| operate      | String | 'Return' operation identification                                                  |
| operateClazz | String | 'Return' operation class path                                                      |
| operateFlag  | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission         |
| operateMsg   | String | Process operation return information                                               |
| status       | int    | Process operation status code                                                      |
| workId       | String | Instance ID                                                                        |
nextNodes parameter description:

| Parameter     | Type   | Description                                                                                                                                                                                          |
|---------------|--------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| authors       | Map    | The key in the operator map of the next node is Author, and value is the Author object parameter.                                                                                                    |
| isDone        | String | Has the process once passed the next node before?                                                                                                                                                    |
| isSelect      | String | Has the next node been selected?                                                                                                                                                                     |
| memo          | String | Memo                                                                                                                                                                                                 |
| nodeGroup     | String | If there are no multiple branches in the current instance, this value is empty. If there are multiple branches, this value returns the node ID of the previous node to bind the grouping information |
| nodeId        | String | Current node ID                                                                                                                                                                                      |
| nodeKey       | String | Current node primary key                                                                                                                                                                             |
| nodeName      | String | Current node name                                                                                                                                                                                    |
| nodeStatus    | String | Node status, limited value, 0. Success; 1. Select operator; 2. Select node; 3. Operator not found;4. Next node not found                                                                             |
| selectId      | String | Next node id to be selected                                                                                                                                                                          |
| selectName    | String | Next node name to be selected                                                                                                                                                                        |
| timeLimit     | String | Node processing deadline                                                                                                                                                                             |
| timeLimitType | String | Processing time limit type, limit value. 0: Calendar day; 1: Working day                                                                                                                             |

### Return to Any Node-Node Settings
Interface Request Invoking Description <br>HTTP request method: POST <br>
Request address:: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b018113f08be70001",
  "trackId": "HZ28858f8113f08b018113f08be90002",
  "actionData": {
    "operate": "jumpreject",
    "operateClazz": "com.horizon.wf.action.ActionRejectByJump",
    "nextNodes": [
      {
        "isSelect": "true",
        "nodeId": "Node1",
        "nodeKey": "Node1",
        "selectId": "Node1"
      }
    ]
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Track ID                                       |
| actionData  | Yes      | Other submitted data                           |
actionData  parameter

| Parameter    | Required | Description                                                           |
|--------------|----------|-----------------------------------------------------------------------|
| operate      | Yes      | 'Return' operation identifier, fixed value:'jumpreject'               |
| operateClazz | Yes      | 'Return' operation class pathcom.horizon.wf.action.ActionRejectByJump |
| nextNodes    | Yes      | Next node information                                                 |
nextNodes parameter description:

| Parameter | Required | Description                      |
|-----------|----------|----------------------------------|
| isSelect  | Yes      | Has the next node been selected? |
| nodeId    | Yes      | Next node ID                     |
| nodeKey   | Yes      | Next node primary key            |
| selectId  | Yes      | Next node id to be selected      |
**Example of returned results:**
```
{
    "alert": "true",
    "nextNodeId": "Node1",
    "nextNodes": [
        {
            "isSelect": "true",
            "nodeId": "Node1",
            "nodeKey": "Node1",
            "selectId": "Node1"
        }
    ],
    "operate": "jumpreject",
    "operateClazz": "com.horizon.wf.action.ActionRejectByJump",
    "operateFlag": "1",
    "operateMsg": "Returned to Any Node successfully",
    "operateStatus": "success",
    "status": 0,
    "trackId": "HZ28858f8113f08b018113f08be90002",
    "workId": "HZ28858f8113f08b018113f08be70001"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                                |
|---------------|--------|----------------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored           |
| nextNodeId    | String | Next node ID                                                               |
| nextNodes     | Object | Next node information                                                      |
| operate       | String | 'Return' operation identification                                          |
| operateClazz  | String | 'Return' operation class path                                              |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission |
| operateMsg    | String | Process operation return information                                       |
| operateStatus | String | Process operation results                                                  |
| status        | int    | Process operation status code                                              |
| trackId       | String | Track ID                                                                   |
| workId        | String | Instance ID                                                                |
nextNodes parameter description:

| Parameter | Required                      | Description                      |
|-----------|-------------------------------|----------------------------------|
| isSelect  | String                        | Has the next node been selected? |
| nodeId    | String                        | Next node ID                     |
| nodeKey   | String  Next node primary key |
| selectId  | String                        | Next node id to be selected      |

## Return Submission
Interface Request Invoking Description <br>HTTP request method: POST <br>
Request address:: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b018113f08be70001",
  "trackId": "HZ28858f8113f08b018113f08be90002",
  "actionData": {
    "operate": "rejectSubmit",
    "operateClazz": "com.horizon.wf.action.ActionSubmitForReject"
  }
}
```

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Track ID                                       |
| actionData  | Yes      | Process operation JSON data                    |
actionData  parameter

| Parameter    | Required | Description                                                                            |
|--------------|----------|----------------------------------------------------------------------------------------|
| operate      | Yes      | 'Return' operation identifier, fixed value:'reject'                                    |
| operateClazz | Yes      | 'Return Submission' operation class path:'com.horizon.wf.action.ActionSubmitForReject' |
**Example of returned results:**
```
{
  "alert": "true",
  "operate": "rejectSubmit",
  "operateClazz": "com.horizon.wf.action.ActionSubmitForReject",
  "operateFlag": "1",
  "operateMsg": "Returned and Submit successfully",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "trackId": "HZ28858f8113f08b018113f08be90002",
  "workId": "HZ28858f8113f08b018113f08be70001"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                                |
|---------------|--------|----------------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored           |
| operate       | String | 'Return' operation identification                                          |
| operateClazz  | String | 'Return Submission' operation class path                                   |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission |
| operateMsg    | String | Process operation return information                                       |
| operateStatus | String | Process operation results                                                  |
| reOpen        | String | Whether to reopen, can be ignored                                          |
| status        | int    | Process operation status code                                              |
| trackId       | String | Track ID                                                                   |
| workId        | String | Instance ID                                                                |

## Return Internally
Interface Request Invoking Description <br>HTTP request method: POST <br>
Request address:: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b01811456bf9e01ae",
  "trackId": "HZ28858f8113f08b01811456bf9e01af",
  "actionData": {
    "operate": "innerreject",
    "operateClazz": "com.horizon.wf.action.ActionRejectForInner"
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Track ID                                       |
| actionData  | Yes      | Process operation JSON data                    |
actionData  parameter

| Parameter    | Required | Description                                                                           |
|--------------|----------|---------------------------------------------------------------------------------------|
| operate      | Yes      | 'Return' operation identifier, fixed value:'innerreject'                              |
| operateClazz | Yes      | 'Return Submission' Operation class path:'com.horizon.wf.action.ActionRejectForInner' |
**Example of returned results:**
```
{
  "alert": "true",
  "operate": "innerreject",
  "operateClazz": "com.horizon.wf.action.ActionRejectForInner",
  "operateFlag": "1",
  "operateMsg": "Returned Internally successfully",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8113f08b01811456bf9e01ae"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                                |
|---------------|--------|----------------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored           |
| operate       | String | 'Return Internally' operation identification                               |
| operateClazz  | String | 'Return Internally'  Operation class path                                  |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission |
| operateMsg    | String | Process operation return information                                       |
| operateStatus | String | Process operation results                                                  |
| reOpen        | String | Whether to reopen, can be ignored                                          |
| status        | int    | Process operation status code                                              |
| workId        | String | Instance ID                                                                |
