# Save{docsify-ignore-all}
> Temporarily save the process data.

Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f80f4ecfe0180ff30bf52017e",
  "trackId": "HZ28858f80f4ecfe0180ff30bf52017f",
  "actionData": {
    "operate": "save",
    "operateClazz":"com.horizon.wf.action.ActionSave"
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Other submitted data                           |
 actionData   Parameter:

| Parameter    | Required | Description                                                          |
|--------------|----------|----------------------------------------------------------------------|
| operate      | Yes      | Operation identification, fixed value:'save'                         |
| operateClazz | Yes      | operation class path, fixed value:'com.horizon.wf.action.ActionSave' |

**Example of returned results:**
```
{
  "alert": "true",
  "operate": "save",
  "operateClazz": "com.horizon.wf.action.ActionSave",
  "operateFlag": "1",
  "operateMsg": "Saved successfully!",
  "operateStatus": "success",
  "reOpen": "true",
  "status": 0,
  "trackId": "HZ28858f80f4ecfe0180ff30bf52017f",
  "workId": "HZ28858f80f4ecfe0180ff30bf52017e"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                                |
|---------------|--------|----------------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored           |
| operate       | String | Operation identification, fixed value                                      |
| operateClazz  | String | 'Temporary save' operation class path, fixed value                         |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission |
| operateMsg    | String | Process operation return information                                       |
| operateStatus | String | Process operation results                                                  |
| reOpen        | String | Whether to reopen, can be ignored                                          |
| status        | int    | Process operation status code                                              |
| trackId       | String | Track ID                                                                   |
| workId        | String | Instance ID                                                                |
