## 流程表单字段权限API说明
### 核心入口类
源代码位置：horizon-workflow-extend开头的jar包内com.horizon.workflow.form路径下。
流程表单字段权限接口获取的工厂类: com.horizon.workflow.form.util.getFlowFieldAuthManager
流程表单字段权限查询接口类：com.horizon.workflow.form.api.FlowFieldAuthApi
流程表单字段权限查询返回类：com.horizon.workflow.form.entity.FieldAuth

### 组织机构数据查询调用说明
查询流程建模时挂载表单时，对表单字段设置的权限。总体调用代码结构如下：
```
//获取操作实现类
FlowFieldAuthApi fieldAuth = formFieldAuthFactory.getFlowFieldAuthManager();
```

### FieldAuth返回结果集说明

| 属性          | 类型     | 是否必须 | 描述                     |
|-------------|--------|------|------------------------|
| id          | String | 是    | 权限ID                   |
| formId      | String | 是    | 表单ID                   |
| authName    | String | 是    | 权限名                    |
| editField   | List   | 否    | 可编辑字段，每一项为表单ID+关联表字段拼接 |
| checkField  | List   | 否    | 必填字段，每一项为表单ID+关联表字段拼接  |
| hiddenField | List   | 否    | 隐藏字段，每一项为表单ID+关联表字段拼接  |
| readField   | List   | 否    | 只读字段，每一项为表单ID+关联表字段拼接  |

## FlowFieldAuthApi方法调用说明
### getFieldAuth
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getFieldAuth</td>
        <td>中文名称</td>
        <td></td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">根据组织机构的类型和ID查找用户</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
</table>

**参数说明**

| 参数名称   | 类型     | 是否必填 | 描述   |
|--------|--------|------|------|
| authId | String | √    | 权限Id |
**调用示例**
```
FlowFieldAuthApi fieldAuthApi = formFieldAuthFactory.getFlowFieldAuthManager();
FieldAuth fieldAuth = fieldAuthApi. getFieldAuth(“HZ28e7f51e816d28011e816da7f1001f”);
```