# 参数说明 

## WorkParaBean传入参数设置说明 
### setFlowId
| 分类   | 描述                       |
|------|--------------------------|
| 参数格式 | 字符串                      |
| 参数含义 | 流程定义时的数据id或者流程定义中设置的流程id |
| 作用范围 | 创建实例                     |
| 是否必须 | 必须                       |

### setOuterConfig
| 分类   | 描述                                                                                      |
|------|-----------------------------------------------------------------------------------------|
| 参数格式 | 字符串                                                                                     |
| 参数含义 | 外部设置标识名称                                                                                |
| 作用范围 | 创建实例                                                                                    |
| 是否必须 | 非必须                                                                                     |
| 其他说明 | 指定从外部设置获取办理人，同时还需要在流程定义中节点办理人处勾选才能生效<br>![流程操作类图](../assets/img/api/setOuterConfig.png) |

### setWorkId
| 分类   | 描述        |
|------|-----------|
| 参数格式 | 字符串       |
| 参数含义 | 实例id      |
| 作用范围 | 打开实例、实例操作 |
| 是否必须 | 必须        |
### setTrackId
| 分类   | 描述                                                                          |
|------|-----------------------------------------------------------------------------|
| 参数格式 | 字符串                                                                         |
| 参数含义 | 当前路径id                                                                      |
| 作用范围 | 打开实例、实例操作                                                                   |
| 是否必须 | 实例操作时必须                                                                     |
| 其他说明 | 打开实例时，如果有多个活动路径，则必须传入一个，否系统会提示选择路径；<br>实例操作时，必须传入，在只有一个活动路径时，可以从打开后的实例对象中获取 |
### setNodeId
| 分类   | 描述                    |
|------|-----------------------|
| 参数格式 | 字符串                   |
| 参数含义 | 当前节点id                |
| 作用范围 | 实例操作                  |
| 是否必须 | 必须                    |
| 其他说明 | 实例操作时，传入当前节点id，必须传入参数 |
### setTenantCode
| 分类   | 描述          |
|------|-------------|
| 参数格式 | 字符串         |
| 参数含义 | 当前租户id      |
| 作用范围 | 打开实例、实例操作   |
| 是否必须 | 必须          |
| 其他说明 | 根据session获取 |
### setFlowIdentifier
| 分类   | 描述                                                                                                                                       |
|------|------------------------------------------------------------------------------------------------------------------------------------------|
| 参数格式 | 字符串                                                                                                                                      |
| 参数含义 | 流程数据源标识                                                                                                                                  |
| 作用范围 | 打开实例、实例操作                                                                                                                                |
| 是否必须 | 必须                                                                                                                                       |
| 其他说明 | 如果不传入，系统自动根据tenantCode从接口方法中获取<br>com.horizon.third.ThirdAdapterFactory.getIdentifierFromTenantid(String tenant)<br>建议直接从当前session中获取并传入 |
### setDataIdentifier
| 分类   | 描述                                    |
|------|---------------------------------------|
| 参数格式 | 字符串                                   |
| 参数含义 | 业务数据源标识符                              |
| 作用范围 | 打开实例、实例操作                             |
| 是否必须 | 必须                                    |
| 其他说明 | 如果此数据源跟 flowIdentifier不一致，则无法在一个事务中处理 |
### setUserId
| 分类   | 描述                                               |
|------|--------------------------------------------------|
| 参数格式 | 字符串<br> 1.U_userid  2.userid  3.U_userid/X_XXXid |
| 参数含义 | 当前用户id                                           |
| 作用范围 | 打开实例、实例操作                                        |
| 是否必须 | 必须                                               |
| 其他说明 | 如果使用setSubjection进行了赋值,则此方式中的X_XXXid会被替换         |
### setSubjection
| 分类   | 描述                                               |
|------|--------------------------------------------------|
| 参数格式 | 字符串<br> 1.U_userid  2.userid  3.U_userid/X_XXXid |
| 参数含义 | 当前用户id                                           |
| 作用范围 | 打开实例、实例操作                                        |
| 是否必须 | 必须                                               |
| 其他说明 | 如果使用setSubjection进行了赋值,则此方式中的X_XXXid会被替换         |
### setAllUserids
| 分类   | 描述                                                                                                                |
|------|-------------------------------------------------------------------------------------------------------------------|
| 参数格式 | 字符串                                                                                                               |
| 参数含义 | 当前用户的所有权限集合                                                                                                       |
| 作用范围 | 打开实例                                                                                                              |
| 是否必须 | 非必须                                                                                                               |
| 其他说明 | 如果不传入，系统会自动调用接口方法获取（如果接口方法有对应实现的话）<br>ThirdAdapterFactory.getOrganizationInstance(tenantid).getAllUserids(userid) |
### setUserName
| 分类   | 描述        |
|------|-----------|
| 参数格式 | 字符串       |
| 参数含义 | 当前用户名称    |
| 作用范围 | 打开实例、实例操作 |
| 是否必须 | 非必须       |
### setDeptName
| 分类   | 描述         |
|------|------------|
| 参数格式 | 字符串        |
| 参数含义 | 当前用户部门名称   |
| 作用范围 | 打开实例、实例操作  |
| 是否必须 | 非必须        |
| 其他说明 | 用于日志记录一些地方 |

### setParentWorkid
| 分类   | 描述                            |
|------|-------------------------------|
| 参数格式 | 字符串                           |
| 参数含义 | 父实例的workid                    |
| 作用范围 | 打开实例                          |
| 是否必须 | 非必须                           |
| 其他说明 | 设置当前实例是否需要继承其他实例数据,一般用于子流程启动时 |
### setNextNodeId
| 分类   | 描述                                                                                                                                                                            |
|------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 参数格式 | 字符串设置流程实例下一个流转节点Id<br>格式:<br>提交操作格式：路由Id~节点Id，多值用“&”分隔<br>除了提交操作外，其他格式都是节点Id,多值用"&"分隔<br>例如提交:<br>Line1~Node1  单值Line1~Node1&Line2~Node2 多值 例如退回:<br>Node1  单值 Node1&Node2 多值 |
| 参数含义 | 下一节点列表                                                                                                                                                                        |
| 作用范围 | 实例操作                                                                                                                                                                          |
| 是否必须 | 必须                                                                                                                                                                            |
| 其他说明 | 执行操作时,设置下一节点。不设置时，系统会自动获取下一节点，如果下一<br>节点确定，则不需要选择，直接后续处理，如果需要选择，则节点id可以从<br>返回值中获取格式信息（主要时考虑有跳过节点的情况下，节点id传入格式<br>稍有不同）                                                       |
### setOtherPara
| 分类                     | 描述              |
|------------------------|-----------------|
| 参数格式                   | LinkedHashMap   |
| key 参数变量名 value: 参数变量值 |
| 参数含义                   | 设置流程实例流转的其他额外参数 |
| 作用范围                   | 流程流转            |
| 是否必须                   | 非必须             |
### setMessageMoulds
| 分类   | 描述                                             |
|------|------------------------------------------------|
| 参数格式 | LinkedHashMap<br>key: 节点Id_参与者类型   value: 待办标题 |
| 参数含义 | 设置流程发送消息模板信息                                   |
| 作用范围 | 流程流转                                           |
| 是否必须 | 非必须                                            |
### setTitle
| 分类   | 描述      |
|------|---------|
| 参数格式 | 字符串     |
| 参数含义 | 流程流转的标题 |
| 作用范围 | 待办      |
| 是否必须 | 非必须     |
### setActionClass
| 分类   | 描述                                             |
|------|------------------------------------------------|
| 参数格式 | 字符串                                            |
| 参数含义 | 操作实现类全路径                                       |
| 作用范围 | 实例操作                                           |
| 是否必须 | 必须                                             |
| 其他说明 | 操作必须实现接口com.horizon.wf.core.work.ICustomAction |
### setSelectSubFlowid
| 分类   | 描述                      |
|------|-------------------------|
| 参数格式 | 字符串                     |
| 参数含义 | 选择的子流程flowid            |
| 作用范围 | 启动子流程                   |
| 是否必须 | 必须                      |
| 其他说明 | 执行启动子流程操作时,传入子流程的flowid |
### setUrlApp
| 分类   | 描述        |
|------|-----------|
| 参数格式 | 字符串       |
| 参数含义 | 待办打开的链接地址 |
| 作用范围 | 待办事宜      |
| 是否必须 | 非必须       |
### setSelectAuthorMap
| 分类   | 描述                                                                                                                                                                                                                                                                                                                                                                                                                            |
|------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 参数格式 | HashMap &#60;String,String&#62; <br>前台选择人员设置格式:<br>key=路由id-参与者类型(Author,reader..)<br>或者是节点id-参与者类型(Author,reader..)<br>或者参与者类型(不涉及到节点变化的设置此值)<br>value=userid(多个使用分号";")<br>例如：<br>LinkedHashMap &#60;String,String&#62; selectedUsers = new LinkedHashMap&#60;String,String&#62;();<br>selectedUsers.put("Line1-Author","xxxx;yyyyy");<br>selectedUsers.put("Line1-Reader","xxxx;yyyyy");<br>注：如果是跳转等操作需要传如下格式：Node1-Author |
| 参数含义 | 节点参与者                                                                                                                                                                                                                                                                                                                                                                                                                         |
| 作用范围 | 实例操作                                                                                                                                                                                                                                                                                                                                                                                                                          |
| 是否必须 | 非必须                                                                                                                                                                                                                                                                                                                                                                                                                           |
| 其他说明 | 使用参数Map替换对象内的Map<br>Userid的格式同setUserId中的参数<br>办理人员格式有以下几种情况：<br>1.U_userid或者userid<br>2.U_userid~U_agentid<br>3.U_userid~U_agentid/X_XXXid<br>4.U_userid/X_XXXid<br>5./X_XXXid或者/XXXid或者X_XXXid必须要有集合类型前缀,否则会按<br>userid归类                                                                                                                                                                                                   |
### putSelectAuthorMap
| 分类   | 描述                                                                                                                                                                                                                                                                                                                                                                                                                           |
|------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 参数格式 | HashMap &#60;String,String&#62;<br>前台选择人员设置格式:<br>key=路由id-参与者类型(Author,reader..)<br>或者是节点id-参与者类型(Author,reader..)<br>或者参与者类型(不涉及到节点变化的设置此值) value=userid(多个使用分号";")<br>例如：<br>LinkedHashMap&#60;String,String&#62; selectedUsers = new LinkedHashMap &#60;String,String&#62;(); <br>selectedUsers.put("Line1-Author","xxxx;yyyyy"); <br>selectedUsers.put("Line1-Reader","xxxx;yyyyy"); <br>注：如果是跳转等操作需要传如下格式：Node1-Author |
| 参数含义 | 节点参与者                                                                                                                                                                                                                                                                                                                                                                                                                        |
| 作用范围 | 实例操作                                                                                                                                                                                                                                                                                                                                                                                                                         |
| 是否必须 | 非必须                                                                                                                                                                                                                                                                                                                                                                                                                          |
| 其他说明 | 把参数Map中的所有值放入对象内的Map,如果对象内已经存在相同key则覆盖<br>Userid的格式同setUserId中的参数<br>办理人员格式有以下几种情况：1.U_userid或者userid<br>2.U_userid~U_agentid<br>3.U_userid~U_agentid/X_XXXid<br>4.U_userid/X_XXXid<br>5./X_XXXid或者/XXXid或者X_XXXid必须要有集合类型前缀,<br>否则会按userid归类                                                                                                                                                                                |
### putSelectAuthor
| 分类   | 描述                                                                                                                                                                                                                                                                                                                                                                                      |
|------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 参数格式 | 前台选择人员设置格式:<br> key=路由id-参与者类型(Author,reader..)<br>或者是节点id-参与者类型(Author,reader..)<br>或者参与者类型(不涉及到节点变化的设置此值)<br>value=userid(多个使用分号";")例如：<br>LinkedHashMap &#60;String,String&#62; selectedUsers = new LinkedHashMap&#60;String,String&#62; ; <br>selectedUsers.put("Line1-Author","xxxx;yyyyy");<br>selectedUsers.put("Line1-Reader","xxxx;yyyyy"); <br>注：如果是跳转等操作需要传如下格式：Node1-Author |
| 参数含义 | 节点参与者                                                                                                                                                                                                                                                                                                                                                                                   |
| 作用范围 | 实例操作                                                                                                                                                                                                                                                                                                                                                                                    |
| 是否必须 | 非必须                                                                                                                                                                                                                                                                                                                                                                                     |
| 其他说明 | 往对象内的Map中放入指定的key和value<br>userid的格式同setUserId中的参数<br>办理人员格式有以下几种情况：<br>1.U_userid或者userid<br>2.U_userid~U_agentid<br>3.U_userid~U_agentid/X_XXXid<br>4.U_userid/X_XXXid<br>5./X_XXXid或者/XXXid或者X_XXXid必须要有集合类型前缀,<br>否则会按userid归类                                                                                                                                                      |
### setMsgSendFlagMap
| 分类   | 描述                                                                                                                                                                                                                                                                                                                               |
|------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 参数格式 | HashMap &#60;String,String&#62;<br> 设置消息发送方式<br>key 消息发送标识(参与者类型)<br>例如:<br> Author 含义主办者 SecondAuthor 含义协办者<br>Reader 含义读者 Done 含义已办理者<br>Manager 含义管理者 Creator  含义创建者<br>value 具体发送方式（多种方式时中间用"&#124;"分隔）<br>例如：<br>Todo  含义待办 Read  含义待阅<br>Mail  含义邮件 Msg   含义系统消息<br>SMS   含义短信<br>IM    含义即时消息 Todo&#124;Read&#124;Mail 多值 |
| 参数含义 | 给下一节点参与者发送消息类型设置                                                                                                                                                                                                                                                                                                                 |
| 作用范围 | 实例操作                                                                                                                                                                                                                                                                                                                             |
| 是否必须 | 非必须                                                                                                                                                                                                                                                                                                                              |
| 其他说明 | 不指定,系统默认使用流程定义中的配置                                                                                                                                                                                                                                                                                                               |
### setSelectAuthorNameMap
| 分类   | 描述                                                                                  |
|------|-------------------------------------------------------------------------------------|
| 参数格式 | HashMap &#60;String,String&#62;<br> key跟selectAuthorMap的key一致,value存放对应的中文名称,用于日志记录 |
| 参数含义 | 节点参与者名称                                                                             |
| 作用范围 | 实例操作                                                                                |
| 是否必须 | 非必须                                                                                 |
### setFlowVarMap
| 分类   | 描述                                                        |
|------|-----------------------------------------------------------|
| 参数格式 | HashMap &#60;String,String&#62;<br>Key=流程变量名称,value=流程变量值 |
| 参数含义 | 流程变量设置                                                    |
| 作用范围 | 实例操作                                                      |
| 是否必须 | 非必须                                                       |
| 其他说明 | 操作执行时,对流程变量进行赋值,不赋值,系统使用默认设置的值                            |
### setBussinessClass
| 分类   | 描述              |
|------|-----------------|
| 分类   | 描述              |
| 参数格式 | 字符串             |
| 参数含义 | 业务数据处理实现类       |
| 作用范围 | 实例操作            |
| 是否必须 | 非必须             |
| 其他说明 | 必须实现接口IBaseRule |
### setBussinessClassForOpenByService
| 分类   | 描述                          |
|------|-----------------------------|
| 参数格式 | 字符串                         |
| 参数含义 | 设置在service中打开实例时,获取业务数据的实现类 |
| 作用范围 | 实例打开                        |
| 是否必须 | 非必须                         |
### setFunname
| 分类   | 描述                                                                               |
|------|----------------------------------------------------------------------------------|
| 参数格式 | 字符串                                                                              |
| 参数含义 | 操作id                                                                             |
| 作用范围 | 实例操作                                                                             |
| 是否必须 | 非必须                                                                              |
| 其他说明 | 对应流程定义使用的配置文件(operate.xml)中的操作id <br>![流程操作类图](../assets/img/api/setFunname.png) |
### setSubmitflag
| 分类   | 描述                                                                       |
|------|--------------------------------------------------------------------------|
| 参数格式 | 字符串                                                                      |
| 参数含义 | 提交操作时,是否持久化开关,不持久化相当于预处理                                                 |
| 作用范围 | 实例操作                                                                     |
| 是否必须 | 非必须                                                                      |
| 其他说明 | 0：确认持久化  1：前后台交互预处理<br>如果不满足操作条件,就算是设置为0,系统也不会持久化,跟1效果一样,<br>只是消耗的资源会多一些 |
### setActionname
| 分类   | 描述                               |
|------|----------------------------------|
| 参数格式 | 字符串                              |
| 参数含义 | 操作中文名称                           |
| 作用范围 | 实例操作                             |
| 是否必须 | 非必须                              |
| 其他说明 | 用于日志记录,如果该值不为空则记录到日志,如果为空则查找按钮名称 |
### setClearMemAfterAction
| 分类   | 描述                               |
|------|----------------------------------|
| 参数格式 | boolean                          |
| 参数含义 | 操作完成后是否清空内存中的对应数据                |
| 作用范围 | 实例操作                             |
| 是否必须 | 非必须                              |
| 其他说明 | 默认true清空,多用于保存操作,即保存后不关闭设置为false |
### setRejectOtherBranch
| 分类   | 描述         |
|------|------------|
| 参数格式 | 字符串        |
| 参数含义 | 是否需要连带退回标识 |
| 作用范围 | 实例操作       |
| 是否必须 | 非必须        |
| 其他说明 | 1是,0否      |
### setMultiInstanceTransaction
| 分类   | 描述                                                                                             |
|------|------------------------------------------------------------------------------------------------|
| 参数格式 | boolean                                                                                        |
| 参数含义 | 是否多实例事务处理                                                                                      |
| 作用范围 | 实例操作                                                                                           |
| 是否必须 | 非必须                                                                                            |
| 其他说明 | 默认false<br>如果设置为true,则系统不进行持久化,由多实例事务调用方执行持久化,此时<br>RunningData中的getFlowMap()才会返回持久化的sql及参数Map |
### setComment
| 分类   | 描述                    |
|------|-----------------------|
| 参数格式 | 字符串                   |
| 参数含义 | 意见                    |
| 作用范围 | 实例操作                  |
| 是否必须 | 非必须                   |
| 其他说明 | 默认写入流程跟踪日志,也可自行确定写入位置 |
### setSxComment
| 分类   | 描述   |
|------|------|
| 参数格式 | 字符串  |
| 参数含义 | 意见2  |
| 作用范围 | 实例操作 |
| 是否必须 | 非必须  |
### setDoNotToFirstNode
| 分类   | 描述                                  |
|------|-------------------------------------|
| 参数格式 | boolean                             |
| 参数含义 | 流程启动时，是否不自动提交到第一个节点。false：自动提交到下一节点 |
| 作用范围 | 实例启动                                |
| 是否必须 | 非必须                                 |
### setNodeLimitForAction参数含数组
| 分类   | 描述                                                                                                                  |
|------|---------------------------------------------------------------------------------------------------------------------|
| 参数格式 | 字符串String nodeid,整形数组 int[] ns                                                                                      |
| 参数含义 | 节点办理时限设置,nodeid:节点Id<br>ns: 数组顺序:<br> 0:办理时限类型(0=工作日,1=自然天,2=小时,3=分)1:办理时长<br>2:警告时长<br>3:允许催办次数数组长度不必为<br>4:允许设置部分 |
| 作用范围 | 实例操作                                                                                                                |
| 是否必须 | 非必须                                                                                                                 |
| 其他说明 ||
### setNodeLimitForAction参数字符串
| 分类   | 描述                                                                                                               |
|------|------------------------------------------------------------------------------------------------------------------|
| 参数格式 | 字符串String nodeid,字符串 String ns                                                                                   |
| 参数含义 | 节点办理时限设置,nodeid:节点Id<br>ns:字符串顺序，多值设置中间用分号连接:<br> 0:办理时限类型(0=工作日,1=自然天,2=小时,3=分)<br>1:办理时长<br>2:警告时长<br>3:允许催办次数 |
| 作用范围 | 实例操作                                                                                                             |
| 是否必须 | 非必须                                                                                                              |
### setNodeLimitSetMap
| 分类   | 描述                                                                                                                              |
|------|---------------------------------------------------------------------------------------------------------------------------------|
| 参数格式 | Map<String,int[]> nodeLimitSetMap                                                                                               |
| 参数含义 | 节点办理时限设置,String 表示nodeid:节点Id<br>ns: 数组顺序:<br>0:办理时限类型(0=工作日,1=自然天,2=小时,3=分)<br>1:办理时长<br>2:警告时长<br>3:允许催办次数数组长度不必为<br>4:允许设置部分 |
| 作用范围 | 实例操作                                                                                                                            |
| 是否必须 | 非必须                                                                                                                             |
### setNextNodeName
| 分类   | 描述              |
|------|-----------------|
| 参数格式 | 字符串             |
| 参数含义 | 动态增加节点时,输入的节点名称 |
| 作用范围 | 实例操作            |
| 是否必须 | 必须              |
### setNextNodeModuleName
| 分类   | 描述                  |
|------|---------------------|
| 参数格式 | 字符串                 |
| 参数含义 | 动态增加节点时,指定拷贝的节点模版名称 |
| 作用范围 | 实例操作                |
| 是否必须 | 非必须                 |
### setNextNodeX
| 分类   | 描述              |
|------|-----------------|
| 参数格式 | 数字              |
| 参数含义 | 动态增加节点时,节点位置坐标X |
| 作用范围 | 实例操作            |
| 是否必须 | 非必须             |
### setNextNodeY
| 分类   | 描述              |
|------|-----------------|
| 参数格式 | 数字              |
| 参数含义 | 动态增加节点时,节点位置坐标Y |
| 作用范围 | 实例操作            |
| 是否必须 | 非必须             |
### setNextNodePosX
| 分类   | 描述             |
|------|----------------|
| 参数格式 | 数字             |
| 参数含义 | 动态节点相对当前节点的X位移 |
| 作用范围 | 实例操作           |
| 是否必须 | 非必须            |
### setNextNodePosY
| 分类   | 描述             |
|------|----------------|
| 参数格式 | 数字             |
| 参数含义 | 动态节点相对当前节点的Y位移 ||
| 作用范围 | 实例操作           |
| 是否必须 | 非必须            |

## WorkResultBean返回结果参数说明
### getResult
| 分类   | 描述                                                                                                                                                                                                                                       |
|------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 返回类型 | int                                                                                                                                                                                                                                      |
| 作用范围 | 打开实例,创建实例,操作执行                                                                                                                                                                                                                           |
| 返回说明 | 获取返回代码<br>0:成功 1：无法获取下一节点 2：提示选择节点 3：提示办理人为空<br>4：提示选择人员5：流程结束 6：子流程未结束<br>7：流程暂停8：流程异常终止 9：其他错误提示<br>14:已经启动过子流程 15：需要选择子流程 16:协办人提交<br>17:不满足合并节点的离开规则<br>22:进入规则调用异常 23：离开规则调用错误<br>24:该节点类型不支持相应的操作--会签、加签<br>25：启用规则调用错误  26：节点激活失败 |
### getBackMsg
| 分类   | 描述             |
|------|----------------|
| 返回类型 | String         |
| 作用范围 | 打开实例,创建实例,操作执行 |
| 返回说明 | 获取返回提示信息       |
### getActiveTrackInfos
| 分类   | 描述                          |
|------|-----------------------------|
| 返回类型 | List &#60;IXmlTrack&#62;    |
| 作用范围 | 打开实例                        |
| 返回说明 | 在执行打开实例后有多条可选的路径时获取活动节点信息列表 |
### getCurTrackInfo
| 分类   | 描述               |
|------|------------------|
| 返回类型 | DBTrack          |
| 作用范围 | 打开实例,创建实例,实例操作执行 |
| 返回说明 | 获取当前路径信息对象       |
### getNextTrackInfos
| 分类   | 描述         |
|------|------------|
| 返回类型 | DBTrack    |
| 作用范围 | 实例操作执行     |
| 返回说明 | 获取下一路径信息列表 |
### getCurNode
| 分类   | 描述             |
|------|----------------|
| 返回类型 | IXmlNode       |
| 作用范围 | 打开实例,创建实例,操作执行 |
| 返回说明 | 获取当前节点配置信息对象   |
### getCurUser
| 分类   | 描述             |
|------|----------------|
| 返回类型 | IRunUser       |
| 作用范围 | 打开实例,创建实例,操作执行 |
| 返回说明 | 当前执行人信息对象      |
### getWork
| 分类   | 描述             |
|------|----------------|
| 返回类型 | DBWork         |
| 作用范围 | 打开实例,创建实例,操作执行 |
| 返回说明 | 获取当前实例信息对象     |
### getFlowInfo
| 分类   | 描述              |
|------|-----------------|
| 返回类型 | IXmlFlowInfo    |
| 作用范围 | 打开实例,创建实例,操作执行  |
| 返回说明 | 获取当前实例对应的流程定义对象 |
### getFlowVarMap
| 分类   | 描述                              |
|------|---------------------------------|
| 返回类型 | HashMap &#60;String,String&#62; |
| 作用范围 | 打开实例,操作执行                       |
| 返回说明 | 当前实例的流程变量Map                    |
### getHashMap
| 分类   | 描述                              |
|------|---------------------------------|
| 返回类型 | HashMap &#60;String,Object&#62; |
| 作用范围 | 操作执行                            |
| 返回说明 | 当前操作执行前传入的参数                    |
### getWorkParaBean
| 分类   | 描述                     |
|------|------------------------|
| 返回类型 | WorkParaBean           |
| 作用范围 | 打开实例,创建实例,操作执行         |
| 返回说明 | 打开实例,创建实例,操作执行时,传入参数对象 |
### getRunningdata
| 分类   | 描述                       |
|------|--------------------------|
| 返回类型 | RunningData              |
| 作用范围 | 打开实例,创建实例,操作执行           |
| 返回说明 | 运行期参数对象,其他参数基本都可以从此对象中获取 |
### getNextNodes
| 分类   | 描述                                                         |
|------|------------------------------------------------------------|
| 返回类型 | INextNode                                                  |
| 作用范围 | 操作执行                                                       |
| 返回说明 | 操作执行交互过程中,获取下一节点列表,用于前台显示时<br>获取节点信息,比如节点是否需要选择人,节点是单选还是多选 |
### getNextNodeids
| 分类   | 描述                                                  |
|------|-----------------------------------------------------|
| 返回类型 | String                                              |
| 作用范围 | 操作执行                                                |
| 返回说明 | 需要传入后台的下一节点列表id字符串一般在确定节点和参<br>与者之后,前台提示确认时直接获取节点信息 |
### getSelectAuthorMap
| 分类   | 描述                                                                                                   |
|------|------------------------------------------------------------------------------------------------------|
| 返回类型 | HashMap &#60;String,String&#62;                                                                      |
| 作用范围 | 操作执行                                                                                                 |
| 返回说明 | 下一节点确定的参与者信息参考setSelectAuthorMap,此map跟setSelectAuthorMap方法中<br>设置的map区别在于,返回的map是经过后台修改过的,可能存在不一致的情况 |
### getTmpAuthorMap
| 分类   | 描述                                |
|------|-----------------------------------|
| 返回类型 | HashMap &#60;String,String&#62;   |
| 作用范围 | 操作执行                              |
| 返回说明 | 下一节点参与者的临时存储列表,不是最终确定的参与者,一般用于交互中 |
### getInitAuthorMap
| 分类   | 描述                              |
|------|---------------------------------|
| 返回类型 | HashMap &#60;String,String&#62; |
| 作用范围 | 操作执行                            |
| 返回说明 | 下一节点定义的参与者列表,不是最终确定的参与者         |
### getSubflowWorks
| 分类   | 描述                               |
|------|----------------------------------|
| 返回类型 | List &#60;DBRelationSubflow&#62; |
| 作用范围 | 启动子流程操作                          |
| 返回说明 | 当前实例对应的已经启动的子流程实例和当前实例关联信息       |
### getSubflows
| 分类   | 描述                             |
|------|--------------------------------|
| 返回类型 | List &#60;IXmlSubFlowInfo&#62; |
| 作用范围 | 启动子流程操作                        |
| 返回说明 | 获取当前可以启动的子流程定义信息               |
### getSubflowWorkResult
| 分类   | 描述           |
|------|--------------|
| 返回类型 | IWorkResult  |
| 作用范围 | 启动子流程操作      |
| 返回说明 | 子流程启动完毕的返回对象 |
### getCurNodeAuthor
| 分类   | 描述                                                                                                                                                                                                                                                                         |
|------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 返回类型 | String                                                                                                                                                                                                                                                                     |
| 作用范围 | 打开实例                                                                                                                                                                                                                                                                       |
| 返回说明 | 获取当前节点的办理人id,用于前台显示办理人员格式有以下几种情况：<br>1.U_userid   或者userid<br>2.U_userid~U_agentid<br>3.U_userid~U_agentid/X_XXXid<br>4.U_userid/D_deptid<br>5./X_XXXid或者/XXXid 或者X_XXXid必须要有集合类型前缀,否则会按userid归类<br>6.[U_userid~U_agentid]/D_deptid<br>7.[U_userid]/D_deptid xml中记录的认领办理记录 |
### getFlowStatusName
| 分类   | 描述          |
|------|-------------|
| 返回类型 | String      |
| 作用范围 | 打开实例        |
| 返回说明 | 转换流程状态为中文显示 |
### getNextSelectTypeByNodeid
| 分类   | 描述                                           |
|------|----------------------------------------------|
| 返回类型 | int                                          |
| 作用范围 | 操作执行                                         |
| 返回说明 | 根据nodeid获取这个节点的选择人员的方式:1单选,2多选(funname也参与计算) |
### getDataidByFormid
| 分类   | 描述                                   |
|------|--------------------------------------|
| 返回类型 | String                               |
| 作用范围 | 打开实例                                 |
| 返回说明 | 根据formid获取业务数据id从TWR_HZ_Instance表中获取 |
### getRelationsByWorkid
| 分类   | 描述                        |
|------|---------------------------|
| 返回类型 | List &#60;DBRelation&#62; |
| 作用范围 | 打开实例                      |
| 返回说明 | 根据workid获取关联关系数据          |
### getWorkid
| 分类   | 描述             |
|------|----------------|
| 返回类型 | String         |
| 作用范围 | 打开实例,创建实例,操作执行 |
| 返回说明 | 返回当前实例id       |
### isNowUserLock
| 分类   | 描述      |
|------|---------|
| 返回类型 | Boolean |
| 作用范围 | 打开实例    |
| 返回说明 | 是否当前人锁定 |
### getLockUser
| 分类   | 描述     |
|------|--------|
| 返回类型 | String |
| 作用范围 | 打开实例   |
| 返回说明 | 返回锁定人  |
### getOpenInstance
| 分类   | 描述           |
|------|--------------|
| 返回类型 | OpenInstance |
| 作用范围 | 打开实例         |
| 返回说明 | 实例打开对象       |
### getCreateInstance
| 分类   | 描述             |
|------|----------------|
| 返回类型 | CreateInstance |
| 作用范围 | 创建实例           |
| 返回说明 | 创建实例对象         |
### getCurButton
| 分类   | 描述                        |
|------|---------------------------|
| 返回类型 | List &#60;IXmlButton&#62; |
| 作用范围 | 打开实例,创建实例                 |
| 返回说明 | 获取当前操作人所能操作的按钮列表          |

