# 代办设置

## 代办设置列表
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/agent/person/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                |
|-------------|------|---------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                     |
| page        | 否    | 页码，如果为空表示查询全部数据                                   |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                             |
| sort        | 否    | 非必须，字段前如果加上减号。如sort=-flowName<br>则为按照flowName倒序排列 |
| search      | 否    | 简单查询流程名称和流程类型字段,默认为空时查询所有数据                       |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "agentUserId": "HZ28821856ef63420156ef6342a20003",
      "agentUserName": "用户02",
      "beginDate": "2022-05-24 00:00:00",
      "endDate": "2022-05-31 23:59:59",
      "flowId": "test3",
      "flowName": "新流程test3",
      "id": "HZ28858f80b703d30180b7069c4c000b",
      "status": "是",
      "typeName": "www",
      "version": "2"
    },
    {
      "agentUserId": "",
      "agentUserName": "",
      "beginDate": "",
      "endDate": "",
      "flowId": "test2",
      "flowName": "新流程test2",
      "id": "",
      "status": "否",
      "typeName": "",
      "version": "1"
    }
  ],
  "message": "",
  "recordsTotal": "3",
  "success": true
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                                                                                  |
|---------------|--------|-------------------------------------------------------------------------------------|
| agentUserId   | String | 代办人用户id                                                                             |
| agentUserName | String | 代办人姓名                                                                               |
| beginDate     | String | 开始时间 <br>格式：yyyy-MM-dd HH:mm:ss                                                     |
| endDate       | String | 结束时间 格式：yyyy-MM-dd HH:mm:ss <br>注：结束日期大于或等于开始日期                                     |
| flowId        | String | 流程模板id                                                                              |
| flowName      | String | 流程名字                                                                                |
| id            | String | 代办表中的数据id                                                                           |
| status        | String | 是否已设置代办<br>是：已设置<br>否：没有设置<br>未设置时id、beginDate、endDate、agentUserId、agentUserName值为空 |
| typeName      | String | 流程分类                                                                                |
| version       | String | 流程版本                                                                                |

## 代办设置操作
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/agent/operate/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "id": "test~新流程test",
  "agentId": "U_HZ28821856ef63420156ef6342a20002",
  "agentName": "用户01",
  "startDate": "2022-05-12",
  "endDate": "2022-05-31",
  "moveTodo": "1",
  "noticeType": "SMS"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                                                              |
|-------------|------|-------------------------------------------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                                                                   |
| id          | 是    | 选中代办设置数据的标识，其值<br>为等于流程id~流程名称，如果选<br>中多条数据进行代办设置，id值用<br>分号隔开。例如：<brtest01~新流程01; test02~新流程02 |
| agentId     | 是    | 代办人id                                                                                           |
| agentName   | 是    | 代办人姓名                                                                                           |
| startDate   | 是    | 开始日期<br>格式：yyyy-MM-dd                                                                           |
| endDate     | 是    | 结束日期<br>格式：yyyy-MM-dd                                                                           |
| moveTodo    | 是    | 是否转移已有待办：<br>1表示是<br>0为否<br>默认情况下为1                                                             |
| noticeType  | 否    | SMS为短信，Msg为系统消息，<br>IM即时消息，Mail为邮件，默认<br>值为空，如果多选，例如：如果<br>多选，中间用逗号隔开，例如：<br>Msg,SMS,IM         |
**返回结果示例：**
```
{
  "success": true,
  "code": 0,
  "message": "设置代办成功"
 }
```

## 取消设置操作
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/agent/cancel/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "id": "test~HZ28858f80b77e670180b793dad70010 "
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                                                                                                                                                                        |
|-------------|------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                                                                                                                                                                             |
| id          | 是    | 取消代办设置业务，选中数据的标识，其值<br>由flowId~dataId组成，其中flowId是流程<br>id，dataId是代办表中的数据id。如果选<br>中多个数据进行取消代办设置业务，id值用<br>分号隔开。例如：<br>yyy00~HZ28868f5cc3367c015cc33abb4d000a;<br>yuwei33~HZ28868f5cc3367c015cc33abb4d000e |
**返回结果示例：**
```
{
  "success": true,
  "code": 0,
  "message": "取消代办成功"
}
```

## 代办业务列表
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/agent/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "requestType": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                           |
|-------------|------|--------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                                |
| requestType | 是    | 业务名称：<br>AgentTransfer表示查询代办移交列表<br>AgentReceive表示查询代办工作接收列表 |
| page        | 否    | 页码，如果为空表示查询全部数据                                              |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                                        |
| sort        | 否    | 非必须，字段前如果加上减号。如sort=-flowName<br>则为按照flowName倒序排列            |
| search      | 否    | 简单查询,默认为空时查询所有数据                                             |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "flowId": "test",
      "flowName": "新流程test",
      "id": "HZ28858f80b77e670180b79a5c8c0023",
      "newName": "用户01",
      "newUser": "HZ28821856ef63420156ef6342a20002",
      "oldName": "",
      "oldUser": "",
      "startTime": "2022-05-12 14:21:25",
      "title": "新流程test"
    }
  ],
  "message": "",
  "recordsTotal": "3",
  "success": true
}
```
**结果参数说明:**

| 参数        | 参数类型   | 描述      |
|-----------|--------|---------|
| flowId    | String | 流程id    |
| flowName  | String | 流程名称    |
| id        | String | 数据id    |
| newName   | String | 接收人姓名   |
| newUser   | String | 接收人用户id |
| oldUser   | String | 移交人用户id |
| oldName   | String | 移交人姓名   |
| startTime | String | 开始时间    |
| title     | String | 查询结果标题  |

## 代办历史记录
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/agent/history/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                          |
|-------------|------|-------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                               |
| page        | 否    | 页码，如果为空表示查询全部数据                                             |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                                       |
| sort        | 否    | 排序，默认为正序，字段前如果<br>加上减号，如sort=-flowName则<br>为按照flowName倒序排列。 |
| search      | 否    | 简单查询,默认为空时查询所有数据                                            |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "agentUserId": "HZ28821856ef63420156ef6342a20003",
      "agentUserName": "用户02",
      "beginDate": "2022-05-24 00:00:00",
      "endDate": "2022-05-31 23:59:59",
      "flowId": "test3",
      "flowName": "新流程test3",
      "id": "HZ28858f80b703d30180b7069c4c000b",
      "status": "失效"
    }
  ],
  "message": "",
  "recordsTotal": "9",
  "success": true
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述            |
|---------------|--------|---------------|
| agentUserId   | String | 代办人id         |
| agentUserName | String | 代办人姓名         |
| beginDate     | String | 代办开始时间        |
| endDate       | String | 代办结束时间        |
| flowId        | String | 流程id          |
| flowName      | String | 流程名称          |
| id            | String | 数据id          |
| status        | String | 限定值：失效，有效，未开始 |

## 代办历史详情
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/agent/dealinfo.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "dataId": "HZ28811c72024d8d0172024da7b60007"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                          |
|-------------|------|-------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                               |
| dataId      | 是    | 代办数据id                                                      |
| page        | 否    | 页码，如果为空表示查询全部数据                                             |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                                       |
| sort        | 否    | 排序，默认为正序，字段前如果<br>加上减号，如sort=-flowName则<br>为按照flowName倒序排列。 |
| search      | 否    | 简单查询,默认为空时查询所有数据                                            |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "beginDate": "2022-05-18 00:00:00",
      "endDate": "2022-05-31 23:59:59",
      "flowId": "test",
      "flowName": "新流程test",
      "saveTime": "2022-05-18 11:18:27",
      "title": "新流程test"
    }
  ],
  "message": "",
  "recordsTotal": "1",
  "success": true
}
```
**结果参数说明:**

| 参数        | 参数类型   | 描述                             |
|-----------|--------|--------------------------------|
| beginDate | String | 代办开始时间                         |
| endDate   | String | 代办结束时间                         |
| flowId    | String | 流程id                           |
| flowName  | String | 流程名称                           |
| saveTime  | String | 发送时间<br>格式:yyyy-MM-dd HH:mm:ss |
| title     | String | 流程标题                           |

## 代办工作接收操作
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/agent/handwork/receivework.wf <br>
**post数据说明：**
```
{
  "accessToken": " ",
  "dataId": "HZ28811c72024d8d0172024da7b60007"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                  |
|-------------|------|---------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识       |
| dataId      | 是    | 代办数据id，多个id中间用分号隔开。 |
**返回结果示例：**
```
{
  "success": true,
  "code": 0,
  "message": "",
  "recordsTotal": "2",
  "data": {
    "HZ2882c0550fa85001550fac06cd00b4": "false",
    "HZ2882c0550fa85001550fac06d100b6": "true"
  }
}
```
**结果参数说明:**

| 参数   | 参数类型 | 描述                                                                |
|------|------|-------------------------------------------------------------------|
| data | Map  | key值为dataId接收数据id<br>value是否接收成功<br>false为此流程接收失败<br>true为此流程接收成功 |

## 代办管理列表
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址:  http://127.0.0.1:8080/demo/horizon/workflow/rest/agent/manage/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                          |
|-------------|------|-------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                               |
| page        | 否    | 页码，如果为空表示查询全部数据                                             |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                                       |
| sort        | 否    | 排序，默认为正序，字段前如果<br>加上减号，如sort=-flowName则<br>为按照flowName倒序排列。 |
| search      | 否    | 简单查询流程名称，代办人姓<br>名，被代办人姓名字段,默认<br>为空时查询所有数据。                |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "agentUserId": "HZ28821856ef63420156ef6342a20002",
      "agentUserName": "用户01",
      "beginDate": "2022-05-13 00:00:00",
      "endDate": "2022-05-31 23:59:59",
      "flowId": "test",
      "flowName": "新流程test",
      "id": "HZ28858f80bb94640180bb974fef001c",
      "status": "是",
      "typeName": "",
      "userId": "admin",
      "userName": "管理员"
    },
    {
      "agentUserId": "",
      "agentUserName": "",
      "beginDate": "",
      "endDate": "",
      "flowId": "test2",
      "flowName": "新流程test2",
      "id": "",
      "status": "否",
      "typeName": "",
      "userId": "",
      "userName": ""
    }
  ],
  "message": "",
  "recordsTotal": "3",
  "success": true
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                                                                                       |
|---------------|--------|------------------------------------------------------------------------------------------|
| agentUserId   | String | 代办人用户id                                                                                  |
| agentUserName | String | 代办人姓名                                                                                    |
| beginDate     | String | 开始时间<br>格式: yyyy-MM-dd HH:mm:ss                                                          |
| endDate       | String | 结束时间<br>格式: yyyy-MM-dd HH:mm:ss                                                          |
| flowId        | String | 流程id                                                                                     |
| flowName      | String | 流程名称                                                                                     |
| id            | String | 流程设置代办后才此数据id                                                                            |
| status        | String | 是否已设置代办<br>是：已设置<br>否：没有设置，未设置时<br>id、beginDate、endDate、<br>agentUserId、agentUserName值为空 |
| typeName      | String | 流程分类                                                                                     |
| userId        | String | 被代办人用户id                                                                                 |
| userName      | String | 被代办人姓名                                                                                   |

## 代办管理设置操作
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址:  http://127.0.0.1:8080/demo/horizon/workflow/rest/agent/manage/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "id": "test2~新流程test2",
  "agentId": "U_HZ28821856ef63420156ef6342a20002",
  "agentName": "用户01",
  "userId": "U_HZ28821856ef63420156ef6342a20003",
  "userName": "用户02",
  "startDate": "2022-05-13",
  "endDate": "2022-05-31",
  "moveTodo": "1",
  "noticeType": "SMS"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                                                              |
|-------------|------|-------------------------------------------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                                                                   |
| id          | 是    | 选中代办设置数据的标识，其值<br>为等于流程id~流程名称，如果选<br>中多条数据进行代办设置，id值用<br>分号隔开。例如：<brtest01~新流程01; test02~新流程02 |
| agentId     | 是    | 代办人id                                                                                           |
| agentName   | 是    | 代办人姓名                                                                                           |
| userId      | 是    | 被代办人id                                                                                          |
| userName    | 是    | 被代办人姓名                                                                                          |
| startDate   | 是    | 开始日期<br>格式：yyyy-MM-dd                                                                           |
| endDate     | 是    | 结束日期<br>格式：yyyy-MM-dd                                                                           |
| moveTodo    | 是    | 是否转移已有待办：<br>1表示是<br>0为否<br>默认情况下为1                                                             |
| noticeType  | 否    | SMS为短信，Msg为系统消息，<br>IM即时消息，Mail为邮件，默认<br>值为空，如果多选，例如：如果<br>多选，中间用逗号隔开，例如：<br>Msg,SMS,IM         |
**返回结果示例：**
```
{
  "success": true,
  "code": 0,
  "message": "设置代办成功"
 }
```