# 协办
> 增加协办、协办提交

![流程操作](../../assets/img/rest/flowaction/addAuthor.png)
## 增加协办
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f816b341e01816b4300f30066",
  "trackId": "HZ28858f816b341e01816b4300f30067",
  "actionData": {
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户01(测试部门0)"
          }
        },
        "isSelect": "true",
        "nodeId": "Node1",
        "nodeKey": "Node1",
        "selectId": "Node1"
      }
    ],
    "operate": "addSecondauthor",
    "operateFlag": "0",
    "operateText": "增加协办",
    "operateClazz": "com.horizon.wf.action.ActionAddSecondAuthor"
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 流程操作json数组    |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                                       |
|--------------|------|----------------------------------------------------------|
| operate      | 是    | 增加协办操作标识：addSecondauthor                                 |
| operateFlag  | 是    | 操作标记，固定值0                                                |
| operateText  | 是    | 操作名称，固定值：”增加协办“                                          |
| operateClazz | 是    | 增加协办操作类路径，固定值com.horizon.wf.action.ActionAddSecondAuthor |
| nextNodes    | 是    | 需要选择的节点列表                                                |
nextNodes参数说明：

| 参数       | 是否必须 | 描述                                     |
|----------|------|----------------------------------------|
| authors  | 是    | 下一节点办理人对象中key为Author,value值为Author对象参数 |
| isSelect | 是    | 是否已选择                                  |
| nodeId   | 是    | 需要选择的节点id                              |
| nodeKey  | 是    | 节点主键                                   |
| selectId | 是    | 需要选择的节点id                              |
authors中Author对象参数说明：

| 参数               | 是否必须 | 描述         |
|------------------|------|------------|
| selectAuthor     | 是    | 节点已选择办理人id |
| selectAuthorName | 是    | 节点已选择办理人名称 |
**返回结果示例：**
```
{
  "nextNodeId": "Node1",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "主办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectType": "checkbox"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "isShowTabs": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node1",
      "nodeKey": "Node1",
      "nodeName": "任务1",
      "nodeStatus": "0",
      "selectId": "Node1",
      "selectName": "协办(任务1)"
    }
  ],
  "operate": "addSecondauthor",
  "operateClazz": "com.horizon.wf.action.ActionAddSecondAuthor",
  "operateFlag": "0",
  "operateMsg": "添加协办成功",
  "status": 0,
  "workId": "HZ28858f8103505e0181035ea9c70040"
}
```
**结果参数说明:**

| 参数           | 参数类型   | 描述                    |
|--------------|--------|-----------------------|
| nextNodeId   | String | 节点id                  |
| nextNodes    | List   | 设置协办的节点列表             |
| operate      | String | 协办操作标识                |
| operateClazz | String | 协办操作类路径               |
| operateText  | String | 操作显示名称                |
| operateFlag  | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg   | String | 返回操作信息                |
| workId       | String | 流程实例id                |
| status       | String | 流程操作结果状态码             |
*nextNodes参数说明：*

| 参数         | 参数类型   | 描述                                                             |
|------------|--------|----------------------------------------------------------------|
| authors    | Map    | 下节点办理人map中key为Author，value为Author对象参数                          |
| isDone     | String | 是否已经走过                                                         |
| isSelect   | String | 是否已选择                                                          |
| isShowTabs | String | 是否显示办理人页签，主要用于运行页面办理人显示，不参与业务处理                                |
| memo       | String | 备注信息                                                           |
| nodeGroup  | String | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id                                |
| nodeId     | String | 节点id                                                           |
| nodeKey    | String | 节点主键                                                           |
| nodeName   | String | 节点名称                                                           |
| nodeStatus | String | 节点状态，限定值<br>0.成功<br>1.选择办理人<br>2.选择节点<br>3.未找到办理人<br>4.未找到下一节点 |
| selectId   | String | 需要选择的节点id                                                      |
| selectName | String | 需要选择的节点名称                                                      |
*authors中Author参数说明：*

| 参数            | 参数类型   | 描述                                     |
|---------------|--------|----------------------------------------|
| authorFlowVar | String | 流程变量                                   |
| authorId      | String | 办理人id（Author）                          |
| authorName    | String | 办理人名称：主办，协办，读者                         |
| freeArea      | String | 自由选择时的范围                               |
| selectType    | String | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选  |
| isFree        | String | 是否自由选择                                 |
| isUser        | String | 是否只允许选择人员                              |
| isDefUser     | String | 流程定义列表中选择                              |
| isSelect      | String | 是否允许选择办理人                              |

## 协办提交
>需要先为流程实例增加协办后，被添加的人员才可以进行协办提交

接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e0181049de50f008f",
  "trackId": "HZ28858f8103505e0181049de50f0090",
  "actionData": {
    "operate": "secondSubmit",
    "operateClazz": "com.horizon.wf.action.ActionSubmitNotLeave"
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 其他提交数据        |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                                      |
|--------------|------|---------------------------------------------------------|
| operate      | 是    | 协办提交操作标识，固定值                                            |
| operateClazz | 是    | 协办提交操作类路径，固定值com.horizon.wf.action.ActionSubmitNotLeave |
**返回结果示例：**
```
{
  "alert": "true",
  "operate": "secondSubmit",
  "operateClazz": "com.horizon.wf.action.ActionSubmitNotLeave",
  "operateFlag": "1",
  "operateMsg": "协办提交成功（不离开节点）",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8103505e0181049de50f008f"
}
```

**结果参数说明:**

| 参数            | 参数类型   | 描述                    |
|---------------|--------|-----------------------|
| alert         | String | 是否弹出操作成功信息，可忽略        |
| operate       | String | 协办提交操作标识              |
| operateClazz  | String | 协办提交操作类路径，固定值         |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg    | String | 流程操作返回信息              |
| operateStatus | String | 流程操作结果                |
| reOpen        | String | 是否重新打开，可忽略            |
| status        | int    | 流程操作状态码               |
| workId        | String | 流程实例id                |
