# 自由提交{docsify-ignore-all}

接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e018113bf63a80505",
  "trackId": "HZ28858f8103505e018113bf63a80506",
  "actionData": {
    "operate": "freesubmit",
    "operateClazz": "com.horizon.wf.action.ActionSubmitForFree",
    "operateFlag": 0,
    "freeNode": {
      "nodeName": "测试自由节点",
      "axisX": "",
      "axisTypeX": "absolute-x",
      "axisY": "",
      "axisTypeY": "absolute-y",
      "authors": {
        "Author": {
          "authorId": "Author",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectType": "checkbox",
          "selectAuthor": "U_admin/D_HZ28821856ef63420156ef63429c0000",
          "selectAuthorName": "管理员(慧正通软)"
        },
        "SecondAuthor": {
          "authorId": "SecondAuthor",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectType": "checkbox",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户01(测试部门0)"
        },
        "Reader": {
          "authorId": "Reader",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectType": "checkbox",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户02(测试部门0)"
        }
      },
      "timeLimit": "0",
      "timeLimitType": "0"
    }
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 流程操作json数据    |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                                     |
|--------------|------|--------------------------------------------------------|
| operate      | 是    | 自由提交操作标识，固定值freesubmit                                 |
| operateClazz | 是    | 自由提交操作类路径，固定值com.horizon.wf.action.ActionSubmitForFree |
| operateFlag  | 是    | 操作标记，固定值0                                              |
| freeNode     | 是    | 自由节点信息                                                 |
feeNode参数说明：

| 参数            | 是否必须 | 描述                                                                                                                          |
|---------------|------|-----------------------------------------------------------------------------------------------------------------------------|
| nodeName      | 是    | 节点名称                                                                                                                        |
| axisTypeX     | 否    | 固定值absolute-x                                                                                                               |
| axisX         | 否    | 自由节点生成在页面的横坐标                                                                                                               |
| axisTypeY     | 否    | 固定值absolute-y                                                                                                               |
| axisY         | 否    | 自由节点生成在页面的纵坐标                                                                                                               |
| authors       | 是    | 下一节点办理人对象中key为SecondAuthor<br>、Reader和Author,value值为Author/SecondAuthor/Reader对象参数 ，没有协办/读者时，参数SecondAuthor/Reader对象参数可以不设置 |
| timeLimit     | 否    | 节点办理时限                                                                                                                      |
| timeLimitType | 否    | 办理时限类型，限定值<br>0：自然日<br>1：工作日                                                                                                |
authors中Author/SecondAuthor/Reader对象参数说明：

| 参数               | 是否必须 | 描述                                                       |
|------------------|------|----------------------------------------------------------|
| authorId         | 否    | 办理人类型id，限定值<br>Author：主办<br>SecondAuthor：协办<br>Reader：读者 |
| isDefUser        | 否    | 流程定义列表中选择                                                |
| isFree           | 否    | 是否自由选择                                                   |
| isSelect         | 否    | 是否允许选择办理人                                                |
| isUser           | 否    | 是否只允许选择人员                                                |
| selectType       | 否    | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选                    |
| selectAuthor     | 是    | 节点已选择办理人id                                               |
| selectAuthorName | 是    | 节点已选择办理人名称                                               |
**返回结果示例：**
```
{
  "freeNode": {
    "authors": {},
    "axisTypeX": "absolute-x",
    "axisTypeY": "absolute-y",
    "axisX": "",
    "axisY": "",
    "nodeName": "测试自由节点",
    "timeLimit": "0",
    "timeLimitType": "0"
  },
  "nextNodeId": "Line7~Node6",
  "nextNodes": [
    {
      "authors": {
        "SecondAuthor": {
          "authorFlowVar": "",
          "authorId": "SecondAuthor",
          "authorName": "协办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户01(测试部门0)",
          "selectType": "checkbox"
        },
        "Reader": {
          "authorFlowVar": "",
          "authorId": "Reader",
          "authorName": "读者",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户02(测试部门0)",
          "selectType": "checkbox"
        },
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "主办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_admin/D_HZ28821856ef63420156ef63429c0000",
          "selectAuthorName": "管理员(慧正通软)",
          "selectType": "radio"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node6",
      "nodeKey": "Line7",
      "nodeName": "测试自由节点",
      "nodeStatus": "0",
      "selectId": "Line7~Node6",
      "selectName": "新路由7(测试自由节点)",
      "timeLimit": "0",
      "timeLimitType": "0"
    }
  ],
  "operate": "freesubmit",
  "operateClazz": "com.horizon.wf.action.ActionSubmitForFree",
  "operateFlag": "0",
  "operateMsg": "提交成功",
  "operateStatus": "success",
  "reOpen": "true",
  "status": 0,
  "trackId": "HZ28858f8103505e018113bf63a80506",
  "workId": "HZ28858f8103505e018113bf63a80505"
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                    |
|---------------|--------|-----------------------|
| freeNode      | Object | 自由提交时，自由节点的参数信息       |
| nextNodeId    | String | 自由节点id，自动生成           |
| nextNodes     | List   | 自由提交参数信息              |
| operate       | String | 自由提交操作标识              |
| operateClazz  | String | 自由提交操作类路径             |
| operateStatus | String | 流程操作结果                |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg    | String | 返回操作信息                |
| reOpen        | String | 是否重新打开                |
| status        | int    | 自由提交操作返回状态值           |
| trackId       | String | 流程实例路径id              |
| workId        | String | 流程实例id                |
freeNode参数说明：

| 参数        | 是否必须   | 描述            |
|-----------|--------|---------------|
| nodeName  | String | 节点名称          |
| axisTypeX | String | 固定值absolute-x |
| axisX     | String | 自由节点生成在页面的横坐标 |
| axisTypeY | String | 固定值absolute-y |
| axisY     | String | 自由节点生成在页面的纵坐标 |
*nextNodes参数说明：*

| 参数            | 参数类型   | 描述                                                                                |
|---------------|--------|-----------------------------------------------------------------------------------|
| nodeKey       | String | 节点主键                                                                              |
| selectId      | String | 需要选择的节点id                                                                         |
| selectName    | String | 需要选择的节点名称                                                                         |
| isSelect      | String | 是否已选择                                                                             |
| isDone        | String | 是否已经走过                                                                            |
| nodeGroup     | String | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id                                                   |
| isShowTabs    | String | 是否显示办理人页签，主要用于运行页面办理人显示，不参与业务处理                                                   |
| timeLimit     | String | 节点办理时限                                                                            |
| timeLimitType | String | 办理时限类型，限定值<br>0：自然日<br>1：工作日                                                      |
| nodeStatus    | String | 节点状态，0.成功<br>1.选择办理人<br>2.选择节点<br>3.未找到办理人<br>4.未找到下一节点                           |
| authors       | Map    | 下节点办理人map中key为SecondAuthor、<br>Reader和Author，value为Author/SecondAuthor/Reader对象参数 |
| memo          | String | 备注信息                                                                              |
*authors中Author/SecondAuthor/Reader参数说明：*

| 参数               | 参数类型   | 描述                                    |
|------------------|--------|---------------------------------------|
| authorId         | String | 办理人id（Author/SecondAuthor/Reader）     |
| authorName       | String | 办理人名称：主办，协办，读者                        |
| selectType       | String | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选 |
| isFree           | String | 是否自由选择                                |
| isUser           | String | 是否只允许选择人员                             |
| isDefUser        | String | 流程定义列表中选择                             |
| isSelect         | String | 是否允许选择办理人                             |
| selectAuthor     | String | 节点已选择办理人id                            |
| selectAuthorName | String | 节点已选择办理人名称                            |

