# 会签
>发起会签、会签提交

![流程操作](../../assets/img/rest/flowaction/huiqian.png)
## 发起会签
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e018112c6620f036b",
  "trackId": "HZ28858f8103505e018112c6620f036c",
  "actionData": {
    "operate": "huiqian",
    "operateFlag": 0,
    "operateText": "发起会签",
    "operateClazz": "com.horizon.wf.action.ActionHuiQian",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户01(测试部门0)"
          }
        },
        "isSelect": "true",
        "nodeKey": "Node1",
        "nodeId": "Node1",
        "selectId": "Node1"
      }
    ]
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| nodeId      | 是    | 节点id          |
| actionData  | 是    | 流程操作json数据    |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                             |
|--------------|------|------------------------------------------------|
| operate      | 是    | 操作标识，固定值huiqian                                |
| operateFlag  | 是    | 操作标识固定值0                                       |
| operateText  | 是    | 操作名称，固定值：”发起会签“                                |
| operateClazz | 是    | 操作具体实现类，固定值com.horizon.wf.action.ActionHuiQian |
| nextNodes    | 是    | 需要选择的节点列表                                      |
nextNodes参数说明：

| 参数       | 是否必须 | 描述                                     |
|----------|------|----------------------------------------|
| authors  | 是    | 下一节点办理人对象中key为Author,value值为Author对象参数 |
| nodeKey  | 是    | 节点主键                                   |
| nodeId   | 是    | 需要选择的节点id                              |
| selectId | 是    | 需要选择的节点id                              |
authors中Author对象参数说明：

| 参数               | 是否必须 | 描述         |
|------------------|------|------------|
| selectAuthor     | 是    | 节点已选择办理人id |
| selectAuthorName | 是    | 节点已选择办理人名称 |
**返回结果示例：**
```
{
    "nextNodeId": "Node1",
    "nextNodes": [
        {
            "authors": {
                "Author": {
                    "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
                    "selectAuthorName": "用户01(测试部门0)"
                }
            },
            "isSelect": "true",
            "nodeKey": "Node1",
            "nodeName": "节点1",
            "selectId": "Node1"
        }
    ],
    "operate": "huiqian",
    "operateClazz": "com.horizon.wf.action.ActionHuiQian",
    "operateFlag": "0",
    "operateMsg": "会签成功",
    "operateStatus": "success",
    "status": 0,
    "workId": "HZ28858f8103505e018112db6ce203b8"
}
```
**结果参数说明:**

| 参数           | 参数类型   | 描述                    |
|--------------|--------|-----------------------|
| operate      | String | 会签操作标识，固定值huiqian     |
| operateClazz | String | 会签操作具体实现类             |
| operateFlag  | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg   | String | 返回操作信息                |
| nextNodeId   | String | 当前节点id                |
| workId       | String | 流程实例id                |
| status       | int    | 流程操作状态码               |
| nextNodes    | List   | 需要选择的节点列表             |
*nextNodes参数说明：*

| 参数         | 参数类型   | 描述                                    |
|------------|--------|---------------------------------------|
| nodeKey    | String | 节点主键                                  |
| selectId   | String | 需要选择的节点id                             |
| selectName | String | 需要选择的节点名称                             |
| isSelect   | String | 是否已选择                                 |
| authors    | Map    | 下节点办理人map中key为Author，value为Author对象参数 |
*authors中Author参数说明：*

| 参数               | 参数类型   | 描述         |
|------------------|--------|------------|
| selectAuthor     | String | 节点已选择办理人id |
| selectAuthorName | String | 节点已选择办理人名称 |

## 会签提交
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e018112db6ce203b8",
  "trackId": "HZ28858f8103505e018112db6ce203b9",
  "actionData": {
    "operate": "huiqianSubmit",
    "operateClazz": "com.horizon.wf.action.ActionSubmitHuiqian"
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 其他提交数据        |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                                   |
|--------------|------|------------------------------------------------------|
| operate      | 是    | 已阅操作标识，固定值huiqianSubmit                              |
| operateClazz | 是    | 会签操作类路径，固定值com.horizon.wf.action.ActionSubmitHuiqian |
**返回结果示例：**
```
{
  "alert": "true",
  "operate": "huiqianSubmit",
  "operateClazz": "com.horizon.wf.action.ActionSubmitHuiqian",
  "operateFlag": "1",
  "operateMsg": "会签提交成功",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8103505e018112db6ce203b8"
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                    |
|---------------|--------|-----------------------|
| alert         | String | 是否弹出操作成功信息，可忽略        |
| operate       | String | 会签操作标识                |
| operateClazz  | String | 会签操作类路径               |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg    | String | 流程操作返回信息              |
| operateStatus | String | 流程操作结果                |
| reOpen        | String | 是否重新打开，可忽略            |
| status        | int    | 流程操作状态码               |
| workId        | String | 流程实例id                |
