# 内部提交{docsify-ignore-all}

接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b01811456bf9e01ae",
  "trackId": "HZ28858f8113f08b01811456bf9e01af",
  "actionData": {
    "authorKey": "Author",
    "nextNodeId": "Node2",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "authorId": "Author",
            "authorName": "主办",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "radio",
            "selectAuthor": "U_admin/D_HZ28821856ef63420156ef63429c0000",
            "selectAuthorName": "管理员(慧正通软)"
          }
        },
        "isSelect": "true",
        "nodeId": "Node2",
        "nodeKey": "Node2",
        "selectId": "Node2"
      }
    ],
    "nodeId": "Node2",
    "operate": "innerSubmit",
    "operateClazz": "com.horizon.wf.action.ActionSubmitForProgressively",
    "operateFlag": 0
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 其他提交数据        |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                                          |
|--------------|------|-------------------------------------------------------------|
| authorKey    | 是    | 办理人身份                                                       |
| nextNodeId   | 是    | 提交节点id                                                      |
| nextNodes    | 是    | 需要选择的节点列表                                                   |
| nodeId       | 是    | 提交节点id                                                      |
| operate      | 是    | 内部提交操作标识innerSubmit                                         |
| operateClazz | 是    | 内部提交操作类路径com.horizon.wf.action.ActionSubmitForProgressively |
| operateFlag  | 是    | 操作标识，固定值0                                                   |
nextNodes参数说明：

| 参数            | 是否必须 | 描述                           |
|---------------|------|------------------------------|
| authors       | 是    | 下节点办理人map中key为Author         |
| isSelect      | 是    | 是否已经选择过                      |
| nodeId        | 是    | 节点id                         |
| nodeKey       | 是    | 节点主键                         |
| selectId      | 是    | 需要选择的节点id                    |
authors中Author对象参数说明：

| 参数               | 是否必须 | 描述                                    |
|------------------|------|---------------------------------------|
| authorId         | 否    | 办理人类型id，限定值<br>Author                 |
| authorName       | 否    | 办理人名称，限定值：主办，协办，读者                    |
| freeArea         | 否    | 自由选择时的范围                              |
| isDefUser        | 否    | 流程定义列表中选择                             |
| isFree           | 否    | 是否自由选择                                |
| isSelect         | 否    | 是否允许选择办理人                             |
| isUser           | 否    | 是否只允许选择人员                             |
| selectType       | 否    | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选 |
| selectAuthor     | 是    | 节点已选择办理人id                            |
| selectAuthorName | 是    | 节点已选择办理人名称                            |
**返回结果示例：**
```
{
  "nextNodeId": "Node2",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "authorId": "Author",
          "authorName": "主办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectAuthor": "U_admin/D_HZ28821856ef63420156ef63429c0000",
          "selectAuthorName": "管理员(慧正通软)",
          "selectType": "radio"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "isShowTabs": "false",
      "nodeGroup": "",
      "nodeId": "Node2",
      "nodeKey": "Node2",
      "nodeName": "任务2",
      "selectId": "Node2",
      "selectName": "内部提交 (任务2)"
    }
  ],
  "operate": "innerSubmit",
  "operateClazz": "com.horizon.wf.action.ActionSubmitForProgressively",
  "operateFlag": "0",
  "operateMsg": "提交成功",
  "operateStatus": "success",
  "status": 0,
  "workId": "HZ28858f8113f08b01811456bf9e01ae"
}
```
**结果参数说明:**

| 参数           | 参数类型   | 描述                    |
|--------------|--------|-----------------------|
| nextNodeId   | String | 当前节点id                |
| nextNodes    | List   | 需要选择的节点列表             |
| operate      | String | 内部提交操作标识              |
| operateClazz | String | 内部提交操作类路径             |
| operateFlag  | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg   | String | 返回操作信息                |
| status       | int    | 流程操作状态码               |
| workId       | String | 流程实例id                |
*nextNodes参数说明：*

| 参数            | 参数类型   | 描述                                                             |
|---------------|--------|----------------------------------------------------------------|
| authors       | Map    | 下节点办理人map中key为Author，value为Author对象参数                          |
| isDone        | String | 是否已经走过                                                         |
| isSelect      | String | 是否已选择                                                          |
| isShowTabs    | String | 是否显示办理人页签，主要用于运行页面办理人显示，不参与业务处理                                |
| nodeGroup     | String | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id                                |
| nodeId        | String | 节点id                                                           |
| nodeKey       | String | 节点主键                                                           |
| nodeName      | String | 节点名称                                                           |
| nodeStatus    | String | 节点状态，限定值<br>0.成功<br>1.选择办理人<br>2.选择节点<br>3.未找到办理人<br>4.未找到下一节点 |
| selectId      | String | 需要选择的节点id                                                      |
| selectName    | String | 需要选择的节点名称                                                      |
*authors中Author参数说明：*

| 参数               | 参数类型   | 描述                                    |
|------------------|--------|---------------------------------------|
| authorId         | String | 办理人id固定值Author                        |
| authorName       | String | 办理人类型名称/主办/协办/读者                      |
| freeArea         | String | 自由选择时的范围                              |
| isDefUser        | String | 流程定义列表中选择                             |
| isFree           | String | 是否自由选择                                |
| isSelect         | String | 是否允许选择办理人                             |
| isUser           | String | 是否只允许选择人员                             |
| selectAuthor     | String | 节点已选择办理人id                            |
| selectAuthorName | String | 节点已选择办理人名称                            |
| selectType       | String | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选 |
