# 转办{docsify-ignore-all}
> 送其他人办理

接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e018112d629e4039d",
  "trackId": "HZ28858f8103505e018112d629e4039e",
  "actionData": {
    "operate": "move",
    "operateClazz": "com.horizon.wf.action.ActionMove",
    "operateFlag": "0",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户01(测试部门0)"
          }
        },
        "isSelect": "true",
        "nodeKey": "Node1",
        "nodeId": "Node1",
        "selectId": "Node1"
      }
    ]
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 流程操作json数据    |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                          |
|--------------|------|---------------------------------------------|
| operate      | 是    | 转办操作标识，固定值move                              |
| operateFlag  | 是    | 转办操作标识固定值0                                  |
| operateClazz | 是    | 操作具体实现类，固定值com.horizon.wf.action.ActionMove |
| nextNodes    | 是    | 需要选择的节点列表                                   |
nextNodes参数说明：

| 参数       | 是否必须 | 描述                                     |
|----------|------|----------------------------------------|
| authors  | 是    | 下一节点办理人对象中key为Author,value值为Author对象参数 |
| isSelect | 是    | 是否选择了节点，固定值true                        |
| nodeKey  | 是    | 节点主键                                   |
| selectId | 是    | 需要选择的节点id                              |
| nodeId   | 是    | 节点id                                   |
authors中Author对象参数说明：

| 参数               | 是否必须 | 描述         |
|------------------|------|------------|
| selectAuthor     | 是    | 节点已选择办理人id |
| selectAuthorName | 是    | 节点已选择办理人名称 |
**返回结果示例：**
```
{
  "nextNodeId": "Node1",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户01(测试部门0)"
        }
      },
      "isSelect": "true",
      "nodeKey": "Node1",
      "nodeId": "Node1",
      "selectId": "Node1"
    }
  ],
  "operate": "move",
  "operateClazz": "com.horizon.wf.action.ActionMove",
  "operateFlag": "0",
  "operateMsg": "转办成功",
  "operateStatus": "success",
  "operateText": "转办",
  "status": 0,
  "workId": "HZ28858f8103505e018112d629e4039d"
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                    |
|---------------|--------|-----------------------|
| nextNodeId    | String | 当前节点id                |
| nextNodes     | List   | 需要选择的节点列表             |
| operate       | String | 转办操作标识                |
| operateClazz  | String | 转办操作类路径               |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg    | String | 返回操作信息                |
| operateStatus | String | 返回操作结果                |
| operateText   | String | 操作显示名称                |
| status        | int    | 流程操作状态码               |
| workId        | String | 流程实例id                |
*nextNodes参数说明：*

| 参数       | 参数类型   | 描述                                    |
|----------|--------|---------------------------------------|
| authors  | Map    | 下节点办理人map中key为Author，value为Author对象参数 |
| isSelect | String | 是否已选择                                 |
| nodeKey  | String | 节点主键                                  |
| nodeId   | String | 节点id                                  |
| selectId | String | 需要选择的节点id                             |
*authors中Author参数说明：*

| 参数               | 参数类型   | 描述         |
|------------------|--------|------------|
| selectAuthor     | String | 节点已选择办理人id |
| selectAuthorName | String | 节点已选择办理人名称 |