# 替换{docsify-ignore-all}
> 替换当前节点的办理人

接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "trackId": "HZ28858f8103505e018104d8a1dc0110",
  "workId": "HZ28858f8103505e018104d8a1dc010f",
  "actionData": { 
    "operate": "replace",
    "operateFlag": 0,
    "operateClazz": "com.horizon.wf.action.ActionReplaceAuthor",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20007/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户06(测试部门0)"
          }
        },
        "isSelect": "true",
        "nodeId": "Node1",
        "nodeKey": "Node1",
        "selectId": "Node1"
      }
    ]
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| nodeId      | 是    | 节点id          |
| actionData  | 是    | 流程操作json数据    |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                                   |
|--------------|------|------------------------------------------------------|
| operate      | 是    | 操作标识，限定值replace                                      |
| operateFlag  | 是    | 操作标识固定值0                                             |
| operateClazz | 是    | 操作具体实现类，限定值com.horizon.wf.action.ActionReplaceAuthor |
| nextNodes    | 是    | 需要选择的节点列表                                            |
nextNodes参数说明：

| 参数         | 是否必须 | 描述                                     |
|------------|------|----------------------------------------|
| nodeKey    | 是    | 节点主键                                   |
| selectId   | 是    | 需要选择的节点id                              |
| selectName | 是    | 需要选择的节点名称                              |
| nodeId     | 是    | 需要选择的节点id                              |
| authors    | 是    | 下一节点办理人对象中key为Author,value值为Author对象参数 |
authors中Author对象参数说明：

| 参数               | 是否必须 | 描述         |
|------------------|------|------------|
| selectAuthor     | 是    | 节点已选择办理人id |
| selectAuthorName | 是    | 节点已选择办理人名称 |
**返回结果示例：**
```
{
  "nextNodeId": "Node1",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "主办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectType": "radio"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "isShowTabs": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node1",
      "nodeKey": "Node1",
      "nodeName": "任务1",
      "nodeStatus": "0",
      "selectId": "Node1",
      "selectName": "替换办理人(任务1)"
    }
  ],
  "operate": "replace",
  "operateClazz": "com.horizon.wf.action.ActionReplaceAuthor",
  "operateFlag": "0",
  "operateMsg": "替换处理人成功",
  "status": 0,
  "workId": "HZ28858f8103505e018104d8a1dc010f"
}
```
**结果参数说明:**

| 参数           | 参数类型   | 描述                                               |
|--------------|--------|--------------------------------------------------|
| nextNodeId   | String | 当前节点id                                           |
| nextNodes    | List   | 需要选择的节点列表                                        |
| operate      | String | 操作标识，固定值replace                                  |
| operateClazz | String | 操作具体实现类com.horizon.wf.action.ActionReplaceAuthor |
| operateFlag  | String | 操作标记 -1：显示关闭，0、1：正常提交                            |
| operateMsg   | String | 返回操作信息                                           |
| status       | int    | 流程操作状态码                                          |
| workId       | String | 流程实例id                                           |
*nextNodes参数说明：*

| 参数         | 参数类型   | 描述                                                             |
|------------|--------|----------------------------------------------------------------|
| authors    | Map    | 下节点办理人map中key为Author，value为Author对象参数                          |
| isDone     | String | 是否已经走过                                                         |
| isSelect   | String | 是否已选择                                                          |
| isShowTabs | String | 是否显示办理人页签，主要用于运行页面办理人显示，不参与业务处理                                |
| memo       | String | 备注                                                             |
| nodeGroup  | String | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id                                |
| nodeId     | String | 节点id                                                           |
| nodeKey    | String | 节点主键                                                           |
| nodeName   | String | 节点名称                                                           |
| nodeStatus | String | 节点状态，限定值<br>0.成功<br>1.选择办理人<br>2.选择节点<br>3.未找到办理人<br>4.未找到下一节点 |
| selectId   | String | 需要选择的节点id                                                      |
| selectName | String | 需要选择的节点名称                                                      |
*authors中Author参数说明：*

| 参数            | 参数类型   | 描述                                     |
|---------------|--------|----------------------------------------|
| authorFlowVar | String | 流程变量                                   |
| authorId      | String | 办理人id固定值Author                         |
| authorName    | String | 办理人名称：主办                               | 
| freeArea      | String | 自由选择时的范围                               |
| isDefUser     | String | 流程定义列表中选择                              |
| isFree        | String | 是否自由选择                                 |
| isSelect      | String | 是否允许选择办理人                              |
| isUser        | String | 是否只允许选择人员                              |
| selectType    | String | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选  |