# 提交{docsify-ignore-all}

接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "flowId": "flowsupport",
  "workId": "HZ2886865bf17466015bf1871de1004b",
  "trackId": "HZ2886865bf17466015bf1872089004c",
  "subjection": "D_HZ28821856ef63420156ef63429c0000",
  "authorKey": "Author",
  "nodeId": "Node1",
  "title": "",
  "actionData": {
    "operate": "submit",
    "operateFlag": 0,
    "operateClazz": "com.horizon.wf.action.ActionSubmit",
    "flowVars": {
      "field1": "123"
    },
    "nextNodes": [
      {
        "nodeKey": "Line2",
        "selectId": "Line2~Node2",
        "selectName": "新路由2(任务2)",
        "isSelect": "true",
        "isDone": "false",
        "nodeGroup": "",
        "isShowTabs": null,
        "timeLimit": "0",
        "timeLimitType": "0",
        "nodeStatus": "4",
        "authors": {
          "SecondAuthor": {
            "authorId": "SecondAuthor",
            "authorName": "协办",
            "selectType": "checkbox",
            "isFree": "true",
            "isUser": "false",
            "isDefUser": "false",
            "isSelect": "true",
            "selectAuthor": null,
            "selectAuthorName": null,
            "required": null,
            "initAuthor": null
          },
          "Reader": {
            "authorId": "Reader",
            "authorName": "读者",
            "selectType": "checkbox",
            "isFree": "true",
            "isUser": "false",
            "isDefUser": "false",
            "isSelect": "true",
            "selectAuthor": null,
            "selectAuthorName": null,
            "required": null,
            "initAuthor": null
          },
          "Author": {
            "authorId": "Author",
            "authorName": "主办",
            "selectType": "radio",
            "isFree": "true",
            "isUser": "false",
            "isDefUser": "false",
            "isSelect": "false",
            "selectAuthor": "U_admin/D_HZ28821856ef63420156ef63429c0000",
            "selectAuthorName": "管理员(慧正通软)",
            "required": null,
            "initAuthor": null
          }
        },
        "nodeId": "Node2",
        "nodeName": "任务2",
        "trackId": null
      }
    ]
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                                                                                       |
|-------------|------|--------------------------------------------------------------------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                                                                                            |
| flowId      | 否    | 流程id                                                                                                                     |
| workId      | 是    | 流程实例id                                                                                                                   |
| trackId     | 是    | 流程路径id                                                                                                                   |
| subjection  | 是    | 提交人所属的组织机构id，<br>比如:部门 id，群组 id，岗位 id 等<br> 提交流程时传入此字段<br> （当提交人属于多身份时，以主办身份打开，该字段必传）<br> 格式为D_xxxid  G_xxxxid  P_xxxxid |
| authorKey   | 否    | 提交人身份标识                                                                                                                  |
| nodeId      | 否    | 节点id                                                                                                                     |
| title       | 否    | 标题                                                                                                                       |
| actionData  | 是    | 流程操作json数据对象                                                                                                             |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                                      |
|--------------|------|---------------------------------------------------------|
| operate      | 是    | 操作提交标识，固定值submit                                        |
| operateFlag  | 是    | 操作标记 -1：显示关闭，0、1正常提交，0 确认提交 1预提交                        |
| operateClazz | 是    | 操作提交操作类路径，固定值com.horizon.wf.action.ActionSubmit         |
| flowVars     | 否    | 流程变量赋值使用,flowVars为map，支持传多个，key变量名，value为变量值            |
| nextNodes    | 否    | 需要选择的节点列表（如果已经设置好路由及办理人信息，可以不填），如果有多路由且没有设置办理人信息，那么属于必填 |
nextNodes参数说明：

| 参数            | 是否必须 | 描述                                                                                                                          |
|---------------|------|-----------------------------------------------------------------------------------------------------------------------------|
| nodeKey       | 是    | 节点主键                                                                                                                        |
 | selectId      | 是    | 需要选择的节点id                                                                                                                   |
 | selectName    | 否    | 需要选择的节点名称                                                                                                                   |
 | isSelect      | 是    | 是否已选择                                                                                                                       |
| isDone        | 否    | 是否已经走过                                                                                                                      | 
| nodeGroup     | 否    | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id，rest提交时可忽略                                                                                  |
 | isShowTabs    | 否    | 是否显示办理人页签，<br>主要用于运行页面办理人显示，<br>不参与业务处理rest提交时可忽略                                                                           |
 | timeLimit     | 否    | 节点办理时限，自然数                                                                                                                  |
 | timeLimitType | 否    | 办理时限类型，限定值<br>0：自然日<br>1：工作日                                                                                                |
 | nodeStatus    | 否    | 节点状态，rest提交时可忽略                                                                                                             |
| authors       | 是    | 下一节点办理人对象中key为SecondAuthor<br>、Reader和Author,value值为Author/SecondAuthor/Reader对象参数<br>没有协办/读者时，SecondAuthor/Reader对象参数可以不设置 |
| nodeId        | 是    | 节点id                                                                                                                        |
| nodeName      | 否    | 节点名称                                                                                                                        |
authors中Author/SecondAuthor/Reader对象参数说明：

| 参数               | 是否必须 | 描述                                                       |
|------------------|------|----------------------------------------------------------|
| authorId         | 否    | 办理人类型id，限定值<br>Author：主办<br>SecondAuthor：协办<br>Reader：读者 |
| authorName       | 否    | 办理人名称，限定值：主办，协办，读者                                       |
| selectType       | 否    | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选                    |
| isFree           | 否    | 是否自由选择                                                   |
| isUser           | 否    | 是否只允许选择人员                                                |
| isDefUser        | 否    | 流程定义列表中选择                                                |
| isSelect         | 否    | 是否允许选择办理人                                                |
| selectAuthor     | 是    | 节点已选择办理人                                                 |
| selectAuthorName | 是    | 节点已选择办理人名称                                               |
| required         | 否    | 办理人必填标识,为true时必填                                         |
| initAuthor       | 否    | 节点初始化办理人id                                               |
**返回结果示例：**
```
{
  "operate": "submit",
  "operateClazz": "com.horizon.wf.action.ActionSubmit",
  "operateText": "提交",
  "operateFlag": "0",
  "operateMsg": "提交成功",
  "reOpen": "false",
  "workId": "HZ2886865c0ec540015c0fb3103700da",
  "trackId": "HZ2886865c0ec540015c0fb3103800db",
  "nodeId": "Node1",
  "nodeName": "任务1",
  "subjection": "",
  "authorKey": "Author",
  "operateStatus": "success",
  "alert": "",
  "messageType": "",
  "nextNodes": [
    {
      "nodeKey": "Line2",
      "selectId": "Line2~Node2",
      "selectName": "新路由2(任务2)",
      "isSelect": "true",
      "isDone": "false",
      "nodeGroup": "",
      "isShowTabs": "",
      "timeLimit": "0",
      "timeLimitType": "0",
      "nodeStatus": "4",
      "authors": {
        "SecondAuthor": {
          "authorId": "SecondAuthor",
          "authorName": "协办",
          "selectType": "checkbox",
          "isFree": "true",
          "isUser": "false",
          "isDefUser": "false",
          "isSelect": "true",
          "selectAuthor": "",
          "selectAuthorName": "",
          "required": "",
          "initAuthor": ""
        },
        "Reader": {
          "authorId": "Reader",
          "authorName": "读者",
          "selectType": "checkbox",
          "isFree": "true",
          "isUser": "false",
          "isDefUser": "false",
          "isSelect": "true",
          "selectAuthor": "",
          "selectAuthorName": "",
          "required": "",
          "initAuthor": ""
        },
        "Author": {
          "authorId": "Author",
          "authorName": "主办",
          "selectType": "radio",
          "isFree": "true",
          "isUser": "false",
          "isDefUser": "false",
          "isSelect": "false",
          "selectAuthor": "U_admin/D_HZ28821856ef63420156ef63429c0000",
          "selectAuthorName": "管理员(慧正通软)",
          "required": "",
          "initAuthor": ""
        }
      },
      "nodeId": "Node2",
      "nodeName": "任务2",
      "trackId": ""
    }
  ],
  "subFlows": ""
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                   |
|---------------|--------|----------------------|
| operate       | String | 提交操作标识               |
| operateClazz  | String | 提交操作类路径              |
| operateText   | String | 操作显示名称               |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1正常提交 |
| operateMsg    | String | 返回操作信息               |
| reOpen        | String | 是否重新打开，可忽略           |
| workId        | String | 流程实例id               |
| trackId       | String | 流程实例路径id             |
| nodeId        | String | 当前节点id               |
| nodeName      | String | 当前节点name             |
| subjection    | String | 提交人身份标识              |
| authorKey     | String | 参与者id                |
| operateStatus | String | 流程操作结果               |
| alert         | String | 是否弹出操作成功信息，可忽略       |
| messageType   | String | 消息发送类型               |
| nextNodes     | List   | 需要选择的节点列表            |
| subFlows      | List   | 子流程列表                |
*nextNodes参数说明：*

| 参数            | 参数类型   | 描述                                                                                |
|---------------|--------|-----------------------------------------------------------------------------------|
| nodeKey       | String | 节点主键                                                                              |
| selectId      | String | 需要选择的节点id                                                                         |
| selectName    | String | 需要选择的节点名称                                                                         |
| isSelect      | String | 是否已选择                                                                             |
| isDone        | String | 是否已经走过                                                                            |
| nodeGroup     | String | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id                                                   |
| isShowTabs    | String | 是否显示办理人页签，主要用于运行页面办理人显示，不参与业务处理                                                   |
| timeLimit     | String | 节点办理时限                                                                            |
| timeLimitType | String | 办理时限类型，限定值<br>0：自然日<br>1：工作日                                                      |
| nodeStatus    | String | 节点状态，限定值<br>0.成功<br>1.选择办理人<br>2.选择节点<br>3.未找到办理人<br>4.未找到下一节点                    |
| authors       | Map    | 下节点办理人map中key为SecondAuthor、<br>Reader和Author，value为Author/SecondAuthor/Reader对象参数 |
*subFlows参数说明：*

| 参数          | 参数类型   | 描述                                     |
|-------------|--------|----------------------------------------|
| subFlowId   | String | 子流程id                                  |
 | subFlowName | String | 子流程名称                                  |
 | isStarted   | String | 是否已经启动                                 |
 | subWorks    | Map    | 子流程实例列表                                |
 | authors     | Obejct | 流程办理人                                  |
 | isSelect    | String | 是否选中                                   |
 | selectType  | String | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选  |
*authors中Author/SecondAuthor/Reader参数说明：*

| 参数               | 参数类型   | 描述                                     |
|------------------|--------|----------------------------------------|
| authorId         | String | 办理人id（Author/SecondAuthor/Reader）      |
| authorName       | String | 办理人名称：主办，协办，读者                         |
| selectType       | String | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选  |
| isFree           | String | 是否自由选择                                 |
| isUser           | String | 是否只允许选择人员                              |
| isDefUser        | String | 流程定义列表中选择                              |
| isSelect         | String | 是否允许选择办理人                              |
| selectAuthor     | String | 节点已选择办理人id                             |
| selectAuthorName | String | 节点已选择办理人名称                             |
| required         | String | 办理人必填标识                                |
| initAuthor       | Map    | 节点初始化办理人id                             |
