# 已办工作

## 已办列表
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/haddone/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "requestType": "",
  "page": "1",
  "limit": "10",
  "sort": "sendTime",
  "search": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                                     |
|-------------|------|------------------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                                          |
| requestType | 是    | 业务名称：<br>HadDone表示查询已办事宜列表<br>HadRead表示查询已阅事宜列表<br>AllowRead表示查询可阅事宜列表 |
| page        | 否    | 页码，如果为空表示查询全部数据                                                        |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                                                  |
| sort        | 否    | 非必须，字段前如果加上减号，如sort=- created则为按照created倒序排列                           |
| search      | 否    | 简单查询标题字段,默认为空时查询所有数据                                                   |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "flowId": "test",
      "flowName": "新流程test",
      "limitTime": "",
      "nodeId": "Node1",
      "nodeName": "任务1",
      "sendSubjectionName": "",
      "sendTime": "2022-05-12 13:27:52",
      "sendUserName": "管理员",
      "subjectionId": "D_HZ28821856ef63420156ef63429c0000",
      "title": "新流程test,已办理.",
      "trackId": "HZ28858f80b6b2380180b6bcdf8f0048",
      "workId": "HZ28858f80b6b2380180b6bcdf8f0047"
    }
  ],
  "message": "",
  "recordsTotal": "1",
  "success": true
}
```
**结果参数说明:**

| 参数           | 参数类型   | 描述                          |
|--------------|--------|-----------------------------|
| flowId       | String | 流程id                        |
| flowName     | String | 流程名称                        |
| sendTime     | String | 发送时间，格式：yyyy-MM-dd HH:mm:ss |
| limitTime    | String | 办理时限                        |
| nodeId       | String | 待办节点id                      |
| nodeName     | String | 待办节点名称                      |
| sendUserName | String | 发送人姓名                       |
| subjectionId | String | 发送人所属组织机构id                 |
| title        | String | 流程标题                        |
| trackId      | String | 路径id                        |
| workId       | String | 实例id                        |

## 已发起列表
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/hadstarted/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                 |
|-------------|------|----------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                      |
| page        | 否    | 页码，如果为空表示查询全部数据                                    |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                              |
| sort        | 否    | 排序，默认为正序。字段前如果加上减号，如sort=-flowName则为按照flowName倒序排列 |
| search      | 否    | 简单查询标题字段,默认为空时查询所有数据                               |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "flowName": "新流程test",
      "id": "HZ28858f80b6b2380180b6bcdf8f0047",
      "startTime": "2022-05-12 13:27:52",
      "title": "新流程test"
    }
  ],
  "message": "",
  "recordsTotal": "1",
  "success": true
}
```
**结果参数说明:**

| 参数        | 参数类型   | 描述                          |
|-----------|--------|-----------------------------|
| flowName  | String | 流程名称                        |
| id        | String | 流程实例id                      |
| startTime | String | 发送时间，格式：yyyy-MM-dd HH:mm:ss |
| title     | String | 流程标题                        |

## 撤办列表
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/undo/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                 |
|-------------|------|----------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                      |
| page        | 否    | 页码，如果为空表示查询全部数据                                    |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                              |
| sort        | 否    | 排序，默认为正序。字段前如果加上减号，如sort=-flowName则为按照flowName倒序排列 |
| search      | 否    | 简单查询标题字段,默认为空时查询所有数据                               |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "flowId": "test",
      "flowName": "新流程test",
      "startTime": "2022-05-12 14:21:25",
      "title": "新流程test",
      "trackId": "HZ28858f80b6ec710180b6ede4ce001d",
      "workId": "HZ28858f80b6ec710180b6ede4ce001c"
    }
  ],
  "message": "",
  "recordsTotal": "1",
  "success": true
}
```
**结果参数说明:**

| 参数        | 参数类型   | 描述                            |
|-----------|--------|-------------------------------|
| flowId    | String | 流程id                          |
| flowName  | String | 流程名称                          |
| startTime | String | 实例发起时间，格式：yyyy-MM-dd HH:mm:ss |
| title     | String | 流程标题                          |
| tracId    | String | 流程路径id                        |
| workId    | String | 流程实例id                        |