# 待办工作

## 待办列表
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/todo/page.wf<br>
**post数据说明：**
```
{
  "accessToken": "",
  "requestType": "",
  "type":"",
  "page": "1",
  "limit": "10",
  "sort": "sendTime",
  "search": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                             |
|-------------|------|----------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                                  |
| requestType | 是    | 业务名称：<br>TodoList表示查询个人待办<br>BackLog表示待办认领<br>MatterRead表示待阅事宜 |
| type        | 否    | 流程分类名称                                                         |
| page        | 否    | 页码，如果为空表示查询全部数据                                                |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                                          |
| sort        | 否    | 非必须，字段前如果加上减号，如sort=-sendTime则为按照sendTime倒序排列                  |
| search      | 否    | 简单查询标题字段,默认为空时查询所有数据                                           |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "flowId": "test",
      "flowName": "新流程test",
      "limitTime": "0(天)",
      "nodeId": "Node2",
      "nodeName": "任务2",
      "sendSubjectionName": "部门",
      "sendTime": "2022-05-12 13:28:02",
      "sendUserName": "管理员",
      "subjectionId": "D_HZ28821856ef63420156ef63429c0000",
      "title": "新流程test,请办理.",
      "trackId": "HZ28858f80b6b2380180b6bcdf8f0048",
      "workId": "HZ28858f80b6b2380180b6bcdf8f0047",
      "type":"测试"
    }
  ],
  "message": "",
  "recordsTotal": "1",
  "success": true
}
```
**结果参数说明:**

| 参数                 | 参数类型   | 描述                          |
|--------------------|--------|-----------------------------|
| flowId             | String | 流程id                        |
| flowName           | String | 流程名称                        |
| limitTime          | String | 办理时限                        |
| nodeId             | String | 待办节点id                      |
| nodeName           | String | 待办节点名称                      |
| sendSubjectionName | String | 所属组织机构名称                    |
| sendTime           | String | 发送时间，格式：yyyy-MM-dd HH:mm:ss |
| sendUserName       | String | 发送人姓名                       |
| title              | String | 流程标题                        |
| trackId            | String | 路径id                        |
| workId             | String | 实例id                        |
| type               | String | 流程分类名称                      |



